<?
/*
Stronghold CMS - Plugin Module
Copyright (C) 2008  Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*/


//retrieve a module from the database
// return the module if succsessful, false if it fails
function load_module($db,$page){
	$db_table_prefix=$GLOBALS["CONFIG"]["db_table_prefix"];
	
	$sql="SELECT a.*,m.*
	FROM ".$db_table_prefix."module AS m, ".$db_table_prefix."module_plugin AS a
	WHERE m.page_id=".$page["page_id"]."
	AND m.version_id=".$page["version_id"]."
	AND m.page_id=a.page_id
	AND m.version_id=a.version_id";
	$rs=$db->query($sql);
	if (count($rs)!=1){ fatal("Could not load content for document ".$page["page_id"].".".$page["version_id"]); }
	return ($rs[0]);
	
	return ($module);
}

//view a module
function view_module($db,$page,$module){
	$b="";
	if ($_SERVER["HTTPS"]=="on"){ $system_access=$_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]; }
	if ($system_access){ $b.="<table border='0'><tr><td width='90%'>\n"; }
	
	//-------------------------------------------------------------------
	// Display the actual page content
	
	// automatic navigation
	if ($module["nav_id"]==1){
		if (count($page["navigation"])>0){
			$b.="<ul>\n";
			foreach ($page["navigation"] as $url => $title){ $b.="<li><a href='".$url."'>".$title."</a></li>\n"; }
			$b.="</ul>\n";
		}
	}
	
	if ($module["include_path"]){
		$path=$_SERVER["DOCUMENT_ROOT"].$module["include_path"];
		if (is_file($path)){ include ($path); } else { $b.="<span class='errormessage'><font size='3'>Could not load plugin - ".$path."</font></span>"; }
	} else {
		$b.="<span class='errormessage'><font size='3'>No plugin specified.</font></span>";
	}
	
	if ($system_access){

		$b.="</td><td>\n";
		
		$b.=box_approvals($db,$page,"plugin",$module["mod_time"]);
		$b.=box_history($db,$page["page_id"],$page["version_id"]);

		$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='stronghold_module_plugin'>\n";
		$b.="<input type='hidden' name='module' value='text'>\n";
		$b.="<input type='hidden' name='page_id' value='".$page["page_id"]."'>\n";
		$b.="<input type='hidden' name='version_id' value='".$page["version_id"]."'>\n";
		$b.="<input type='hidden' name='stronghold_form' value='1'>\n";

		$buttons="";
		
		//permissions button
		$admin=has_admin($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]);
		if ($admin){ $buttons.=button_href("Permissions","/stronghold/permissions.php?page_id=".$page["page_id"],"permissions.gif")."<br>"; }

		//approval button
		foreach ($system_access AS $gid => $value){ /* do nothing */ } //get the group id
		if (has_access($page["workflows"],2,$system_access)){
			if ($module["status"]!=2 || in_array($gid,$page["approvals"])){ $disable=true; } else { $disable=false; } //if not pending or it's already approved by this specific group
			$buttons.=button_submit("stronghold_module_plugin","approve","Approve","approve.gif",$disable)."<br>";
		}

		//edit button
		if (!in_array($module["status"],array(1,2)) || $page["archive_date"]!=NULL){ $disable=true; } else { $disable=false; }
		$buttons.=button_href("Edit",prepare_str($_SERVER["PHP_SELF"])."?mode=edit&version_id=".$page["version_id"],"edit.gif",$disable)."<br>";
		
		//new version button
		$buttons.=button_href("New Version","/stronghold/confirm.php?mode=new_version&version_id=".$page["version_id"]."&url=".urlencode(prepare_str($_SERVER["PHP_SELF"])),"new_version.gif")."<br>";
		if ($module["status"]==4 || $page["archive_date"]!=NULL){ $disable=" disabled"; } else { $disable=NULL; }
		
		//cancel version button
		$buttons.=button_href("Cancel Version","/stronghold/confirm.php?mode=cancel_version&version_id=".$page["version_id"]."&url=".urlencode(prepare_str($_SERVER["PHP_SELF"])),"cancel_version.gif")."<br>";
		
		//archive page button
		if ($page["archive_date"]!=NULL){ $disable=true; } else { $disable=false; }
		$buttons.=button_href("Archive Page","/stronghold/archive_page.php?page_id=".$page["page_id"],"archive.gif",$disable)."<br>";

		$b.=menu_box("Document Options",$buttons);

		$b.="</form>\n";		
		//$b.="<br>\n");
		
		$buttons=button_href("Return to Menu","/stronghold/menu.php","return.gif")."<br>";
		if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."labyrinth_domain"]){ $buttons.=button_href("Labyrinth","https://".urldecode($_SESSION[$GLOBALS["CONFIG"]["system_session"]."labyrinth_domain"]),"labyrinth.gif")."<br>"; }
		$buttons.=button_href("Logout","/stronghold/login.php?logout=yes","logout.gif")."<br>";
		$b.=menu_box("General",$buttons);

		$b.="</td></tr></table>\n";
		
		$b.="<input type='button' value='Return to Menu' onclick='window.location=\"/stronghold/menu.php\"'>\n";
		
		$b.="<br><br><table border='1' class='dtable' width='100%'>\n";
		$b.="<tr><th>Revision Notes</th></tr>\n";
		$b.="<tr><td>";
		if ($module["notes"]){ $b.=decode($module["notes"]); } else { $b.="<div align='center'><br><em>None.</em><br><br></div>\n"; }
		$b.="</td></tr>\n";
		$b.="</table>\n";
	}
	
	$document=array();
	$document["body"]=$b;
	$document["title"]=decode($module["title"]);
	if ($module["heading"]){ $document["heading"]=$document["title"]; } //ability to turn of headings
	$document["mod_time"]=$module["mod_time"];
	
//	if ($publish_user){ $document["creator"]=$publish_user["firstname"]." ".$publish_user["surname"]; }
	if ($module["publish_time"]){ $document["date"]=$module["publish_time"]; }
	$document["identifier"]=prepare_str("http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]);
	
	
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
}

//cancel a module
function cancel_module($db,$page,$module){

}

// Create a Module
// return true on success, an error message if it fails
function create_module($db,$db_table_prefix,$user,$module){
	if ($module["page_id"]==NULL){ return ("Plugin Module Creation Fault: No page_id specified"); }
	if ($module["version_id"]==NULL){ return ("Plugin Module Creation Fault: No version_id specified"); }

	//insert the module
	$new_module=array();
	$new_module["page_id"]=$module["page_id"];
	$new_module["version_id"]=$module["version_id"];
	$new_module["include_path"]="'".$module["include_path"]."'";
	$new_module["notes"]="NULL";
	$sql="INSERT INTO ".$db_table_prefix."module_plugin (".implode(",",array_keys($new_module)).") VALUES (".implode(",",$new_module).")";
	//echo ($sql); exit();
	$db->query($sql);
	
	return (true);
}

// Duplicate an existing module
// return true on success, an error message if it fails
function revise_module($db,$db_table_prefix,$module){
	//$result=create_module($db,$db_table_prefix,$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"],$module);
	//if ($result!==true){ return ($result); }
	return (true);
}

//the edit view of a module
function edit_module($db,$page,$module,$errors=NULL){

	$tbl=retrieve_tbls($db,$GLOBALS["CONFIG"]["db_common_prefix"]);
	$tbls=array();
	foreach ($tbl as $tbl_id => $values){ $tbls[$tbl_id]=$values["major"].".".$values["minor"]." ".$values["def"]; }
	//pre($tbls);
	//pre($module);
	
	$b.="<table border='0'><tr><td>\n";
	$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='stronghold_module_plugin'>\n";
	$b.="<input type='hidden' name='module' value='plugin'>\n";
	$b.="<input type='hidden' name='page_id' value='".$page["page_id"]."'>\n";
	$b.="<input type='hidden' name='version_id' value='".$page["version_id"]."'>\n";
	$b.="<input type='hidden' name='stronghold_form' value='1'>\n";
	//$b.="<input type='hidden' name='action_hook' value=''>\n";
	
	$b.="<table border='0' class='dtable'>\n";
	$b.="<tr>\n";
	$b.="<th>Normal Title</th>\n";
	$tip="The full title of your document.";
	$b.="<td><input type='text' name='text_title' value='".$module["title"]."'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Short Title</th>\n";
	$tip="A short title (less than 20 characters). This is used on navigation menus and areas with limitted real-estate.";
	$b.="<td><input type='text' name='text_short_title' value='".$module["short_title"]."' maxlength='20'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Category</th>\n";
	$tip="Triple Bottom Line Category. Please select the category that corresponds to the information in your document.";
	$b.="<td>".generic_select("tbl_id",$tbls,$module["tbl_id"]).tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Heading</th>\n";
	$tip="Uncheck to turn the H1 heading off for this page.";
	$b.="<td><input type='checkbox' name='heading' value='1'"; if ($module["heading"]){ $b.=" checked"; } $b.="> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Auto-Nav</th>\n";
	$tip="Uncheck to turn off the automatically generated menus for this page.";
	$b.="<td><input type='checkbox' name='nav_id' value='1'"; if ($module["nav_id"]){ $b.=" checked"; } $b.="> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Plugin Path</th>\n";
	$tip="The relative path to your plugin.";
	$b.="<td><input type='text' name='include_path' value='".$module["include_path"]."' size='50'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";	
	$b.="</table>";
	$b.="\n";

	$b.="<br>\n";
	if (in_array($module["status"],array(1,2,4))){ $b.=button_submit("stronghold_module_plugin","update","Update","save.gif"); }
	if ($module["status"]==1){ $b.=button_submit("stronghold_module_plugin","approve","Submit for Approval","submit.gif"); }

	$b.="<br><br>\n";
	$b.=button_href("Return to Menu",prepare_str($_SERVER["PHP_SELF"]),"return.gif");

	$b.="<br><br>\n";
	$b.="<table border='1' class='dtable'>\n";
	$b.="<tr><th>Add Revision Note</th></tr>\n";
	$b.="<tr><td align='center'>\n";
	$b.="<textarea rows='6' cols='80' name='notes'></textarea><br>\n";
	$b.=button_submit("stronghold_module_text","append_note","Append Note","note.gif");
	$b.="<tr><th>Revision Notes</th></tr>\n";
	$b.="<tr><td>";
	if ($module["notes"]){ $b.=decode($module["notes"]); } else { $b.="<div align='center'><br><em>None.</em><br><br></div>\n"; }
	$b.="</td></tr>\n";
	$b.="</table>\n";
	$b.="</form>\n";
	
	$b.="</td><td>\n";
	$b.=box_approvals($db,$page,"plugin",$module["mod_time"]);
	$b.="</td></tr></table>";
	
	$head_title=$module["title"];
	$head_breadcrumbs=$page["parents"];
	$javascript["tooltip"]=1;
	
	$document=array();
	$document["body"]=$b;
	$javascript["tooltip"]=1;
	$javascript["submit_once"]=1;
	
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");

}

//post a module
function post_module($db,$page,$module){
	$db_table_prefix=$GLOBALS["CONFIG"]["db_table_prefix"];
	$db_common_prefix=$GLOBALS["CONFIG"]["db_common_prefix"];
	$user_id=$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"];

	//variable protection
	$page_id=prepare_int($_POST["page_id"]);
	$version_id=prepare_int($_POST["version_id"]);
	$title=prepare_str($_POST["text_title"]);
	$short_title=prepare_str($_POST["text_short_title"]);
	$heading=prepare_int($_POST["heading"]);
	$nav_id=prepare_int($_POST["nav_id"]);
	$notes=prepare_txt($_POST["notes"]);
	$include_path=prepare_str($_POST["include_path"]);
	
	if ($page_id==NULL){ fatal("No page specified."); }
	if ($version_id==NULL){ fatal("No version specified."); }
	if ($heading!=1){ $heading=0; }
	if ($nav_id!=1){ $nav_id=0; }
	

	if ($_POST["approve"]=="Approve"){ //direct compare, no no need for prepare_str
		if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]>1){ approve_module($db,$db_table_prefix,$page,$version_id); }
	} else {
	
		//error checking
		$errors=array(0,0);
		if ($title==NULL){ $errors[0]=1; }

		if (!in_array(1,$errors)){

			$user=retrieve_user($db,$db_common_prefix,"user_id",$user_id);
			if (!$user){ fatal ("Could not load user information."); } 

			//add the revision notes
			if ($notes){
				$notes=rev_note($notes,$module["notes"],$user["firstname"]." ".$user["surname"]);
				log_edit($db,$db_table_prefix,$user_id,"REV_NOTE",$page_id,$version_id);
			}
			
			//update the header
			$update=array();
			$update["title"]=$title;
			$update["short_title"]=$short_title;
			$update["heading"]=$heading;
			$update["nav_id"]=$nav_id;
			$update["mod_time"]=time();
			$update["mod_userid"]=$user_id;
			//pre($page); exit();
			$result=update_module_header($db,$db_table_prefix,$page_id,$version_id,$update);
			if ($result!==true){ fatal($result); }
			
			//update the module
			$update=array();
			$update["include_path"]=$include_path;
			$update["notes"]=$notes;			
			$result=update_module($db,$db_table_prefix,$page_id,$version_id,$update);
			if ($result!==true){ fatal($result); }
			
			log_edit($db,$db_table_prefix,$user_id,"UPDATE",$page_id,$version_id);
		}
	}

	unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	header ("Location: ".$page["url"]."?version_id=".$page["version_id"]); exit(); //redirect the view of the page
	//edit_module($db,$page,$module);
}

//approve a module
function approve_module($db,$db_table_prefix,$page,$version){
	generic_approve_module($db,$db_table_prefix,$page,$version);
	return (true);
}

//update a module, return true if OK, error if it fails
function update_module($db,$db_table_prefix,$page_id,$version_id,$module){
	//check for errors
	if ($page_id==NULL){ return ("Module Fault: No page id specified."); }
	if ($version_id==NULL){ return ("Module Fault: No version id specified."); }
	$result=field_check($module,array("include_path","notes"),array(),array(),"Module Fault");
	if ($result!==true){ return ($result); }
	
	//SQLize some of the variables
	$module["include_path"]="'".$module["include_path"]."'";
	$module["notes"]="'".$module["notes"]."'";
	
	//do the update
	$sql="UPDATE ".$db_table_prefix."module_plugin SET ";
	$options=array();
	foreach ($module as $key => $value){ $options[]=$key."=".$value; }
	$sql.=implode(",",$options);
	$sql.=" WHERE page_id=".$page_id." AND version_id=".$version_id;	
	$db->query($sql);

	return (true);
}

function lock_module($db,$db_table_prefix,$page_id,$version_id,$user_id){
	$user_id=generic_lock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	return ($user_id);
}

function unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id){
	generic_unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	return (true);
}

?>
