<?
/*
Stronghold CMS - Text Module
Copyright (C) 2008  Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


*/
$status_codes=array(1=>"New",2=>"Pending",3=>"Approved",4=>"Cancelled");

/*
load_module($db,$page)
view_module($db,$page,$module)
new_module($db,$page,$module)
edit_module($db,$page,$module,$errors=NULL)
post_module($db,$page,$module)
approve_module($db,$page,$version_id)
cancel_module()
*/

function load_module($db,$page){
	//module information
	$db_table_prefix=$GLOBALS["CONFIG"]["db_table_prefix"];
	$sql="SELECT t.*,m.*,l.user_id AS publish_user,l.timestamp AS publish_time".
		" FROM ".$db_table_prefix."module AS m".
		" INNER JOIN ".$db_table_prefix."module_text AS t ON (m.page_id=t.page_id AND m.version_id=t.version_id)".
		" LEFT JOIN ".$db_table_prefix."editlog AS l ON (l.event=7 AND m.page_id=l.page_id AND m.version_id=l.version_id)".
		" WHERE m.page_id=".$page["page_id"].
		" AND m.version_id=".$page["version_id"];
	$rs=$db->query($sql);
	//pre($rs[0]); exit();
	//echo ptable($rs); exit();
	if (count($rs)==0){ fatal("Text Module Loading Fault: Could not load content for document ".$page["page_id"].".".$page["version_id"]); }
	if (count($rs)>1){ fatal("Text Module Loading Fault: Multiple create events recorded for document ".$page["page_id"].".".$page["version_id"]); }
	return ($rs[0]);
}

function view_module($db,$page,$module){
	$b="";
	if ($_SERVER["HTTPS"]=="on"){ $system_access=$_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]; }
	if ($system_access){ $b.="<table border='0'><tr><td width='90%'>\n"; }
	
	//-------------------------------------------------------------------
	// Display the actual page content
	
	// automatic navigation
	if ($module["nav_id"]==1){
		if (count($page["navigation"])>0){
			$b.="<ul>\n";
			foreach ($page["navigation"] as $url => $title){ $b.="<li><a href='".$url."'>".$title."</a></li>\n"; }
			$b.="</ul>\n";
		}
	}
	
	//display the content (only eval if it doesn't contain php) <- we should add a db field so we don't needs to strpos()
	// I need to look into output buffering
	if (strpos ($module["body_text"],"<?")!==false){
		eval("?>".$module["body_text"]."<?");
	} else {
	
		$compare_id=prepare_int($_GET["compare_id"]);
		if ($compare_id){
			//load the previous version
			$sql="SELECT body_text FROM ".$GLOBALS["CONFIG"]["db_table_prefix"]."module_text WHERE page_id=".$page["page_id"]." AND version_id=".$compare_id;
			$rs=$db->query($sql);
			//compare them
			$compare_text=$rs[0]["body_text"];
			$b.=html_diff($module["body_text"],$compare_text);
		} else {
			//warn on empty alt tags (accessibility)
			if ($system_access && strpos($module["body_text"],"alt=\"\"")!==false){ $b.="<p class='errormessage'>Document contains images with empty alt descriptions!</p>"; }
			//display the document. 30,000 lines of code and this is it???
			$b.=$module["body_text"];
		}
	}
	
	if ($system_access){

		$b.="</td><td>\n";
		
		$b.=box_approvals($db,$page,"text",$module["mod_time"]);

		$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='stronghold_module_text'>\n";
		$b.="<input type='hidden' name='module' value='text'>\n";
		$b.="<input type='hidden' name='page_id' value='".$page["page_id"]."'>\n";
		$b.="<input type='hidden' name='version_id' value='".$page["version_id"]."'>\n";
		$b.="<input type='hidden' name='stronghold_form' value='1'>\n";
		//$b.="<input type='hidden' name='action_hook' value=''>\n";

		$buttons="";
		//permissions button
		$admin=has_admin($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]);
		if ($admin){ $buttons.=button_href("Permissions","/stronghold/permissions.php?page_id=".$page["page_id"],"permissions.gif")."<br>"; }

		$permission=retrieve_permission_effective($db,$GLOBALS["CONFIG"]["db_table_prefix"],$page["page_id"],$_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]);

		//approval button
		//pre($system_access);
		foreach ($system_access AS $gid => $value){ /* do nothing */ } //get the group id
		if (has_access($page["workflows"],2,$system_access)){
			if ($module["status"]!=2 || in_array($gid,$page["approvals"])){ $disable=true; } else { $disable=false; } //if not pending or it's already approved by this specific group
			$buttons.=button_submit("stronghold_module_text","approve","Approve","approve.gif",$disable)."<br>";
		}

		//edit button
		if (!in_array($module["status"],array(1,2)) || $page["archive_date"]!=NULL){ $disable=true; } else { $disable=false; }
		$buttons.=button_href("Edit",prepare_str($_SERVER["PHP_SELF"])."?mode=edit&version_id=".$page["version_id"],"edit.gif",$disable)."<br>";
		
		//new version button
		$buttons.=button_href("New Version","/stronghold/confirm.php?mode=new_version&version_id=".$page["version_id"]."&url=".urlencode(prepare_str($_SERVER["PHP_SELF"])),"new_version.gif")."<br>";
		if ($module["status"]==4 || $page["archive_date"]!=NULL){ $disable=" disabled"; } else { $disable=NULL; }
		
		//cancel version button
		$buttons.=button_href("Cancel Version","/stronghold/confirm.php?mode=cancel_version&version_id=".$page["version_id"]."&url=".urlencode(prepare_str($_SERVER["PHP_SELF"])),"cancel_version.gif")."<br>";
		
		//archive page button
		if ($page["archive_date"]!=NULL){ $disable=true; } else { $disable=false; }
		$buttons.=button_href("Archive Page","/stronghold/archive_page.php?page_id=".$page["page_id"],"archive.gif",$disable)."<br>";

		$b.=menu_box("Document Options",$buttons);
		$b.="</form>\n";		
		
		$buttons=button_href("Return to Menu","/stronghold/menu.php","return.gif")."<br>";
		if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."labyrinth_domain"]){ $buttons.=button_href("Labyrinth","https://".urldecode($_SESSION[$GLOBALS["CONFIG"]["system_session"]."labyrinth_domain"]),"labyrinth.gif")."<br>"; }
		$buttons.=button_href("Logout","/stronghold/login.php?logout=yes","logout.gif")."<br>";
		$b.=menu_box("General",$buttons);
		
		$b.=box_history($db,$page["page_id"],$page["version_id"]);
		
		$b.="</td></tr></table>\n";
		
		$b.="<br><br><table border='1' class='dtable' width='100%'>\n";
		$b.="<tr><th>Revision Notes</th></tr>\n";
		$b.="<tr><td>";
		if ($module["notes"]){ $b.=decode($module["notes"]); } else { $b.="<div align='center'><br><em>None.</em><br><br></div>\n"; }
		$b.="</td></tr>\n";
		$b.="</table>\n";
	}
	
	$publish_user=retrieve_user($db,$GLOBALS["CONFIG"]["db_table_prefix"],"user_id",$module["publish_user"]);

	//pre($module); exit();
	$document=array();
	$document["body"]=$b;
	$document["title"]=decode($module["title"]);
	if ($module["heading"]){ $document["heading"]=$document["title"]; } //ability to turn of headings
	$document["mod_time"]=$module["mod_time"];
	if ($publish_user){ $document["creator"]=$publish_user["firstname"]." ".$publish_user["surname"]; }
	if ($module["publish_time"]){ $document["date"]=$module["publish_time"]; }
	//$document["identifier"]=$page["page_id"].".".$page["version_id"];
	$document["identifier"]=$_SERVER["SCRIPT_URI"];
	
	$javascript["go"]=1;
	
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
}


function cancel_module($db,$page,$module){
	if ($page["page_id"]==NULL){ fail ("Module Cancellation Fault: No page_id specified."); }
	if ($module["version_id"]==NULL){ fail ("Module Cancellation Fault: No version_id specified."); }
	
	$sql="UPDATE ".$GLOBALS["CONFIG"]["db_table_prefix"]."module SET".
		" mod_time=".time().",".
		" mod_userid=".$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"].",".
		" status=4".
		" WHERE page_id=".$page["page_id"]." AND version_id=".$module["version_id"];
//echo ($sql); exit();
	$db->query($sql);
	
	return (true);
}

//create a module, and return an error message if it fails
//update_module($db,$db_table_prefix,$page_id,$version_id,$module){
function create_module($db,$db_table_prefix,$user,$module){

	if ($module["page_id"]==NULL){ return ("Text Module Creation Fault: No page_id specified"); }
	if ($module["version_id"]==NULL){ return ("Text Module Creation Fault: No version_id specified"); }

	//insert the module
	$new_module=array();
	$new_module["page_id"]=$module["page_id"];
	$new_module["version_id"]=$module["version_id"];
	$new_module["body_text"]="'".prepare_txt($module["body_text"])."'";
	$new_module["notes"]="NULL";
	$sql="INSERT INTO ".$db_table_prefix."module_text (".implode(",",array_keys($new_module)).") VALUES (".implode(",",$new_module).")";
	//echo ($sql); exit();
	$db->query($sql);
	
	return (true);
}

// Duplicate an existing module
function revise_module($db,$db_table_prefix,$module){
	//pre($module); exit();
	if (!is_array($module)){ return ("Text Module Revision Fault: No module array specified"); }

	//check the array for errors
	$compulsory=array("page_id","version_id","title","short_title","body_text","heading","status","created_date","nav_id","mod_time","mod_userid");
	$optional=array();
	$not_null=array("page_id","version_id","title","short_title","status","created_date","nav_id","mod_time","mod_userid");
	$result=field_check($module,$compulsory,$optional,$not_null,"Text Module Revision Fault");
	if ($result!==true){ return ($result); }
	
	$now=time();

	//create the module header
	$update=array();
	$update["page_id"]=$module["page_id"]; //find the newly inserted page_id
	$update["version_id"]=$module["version_id"];
	$update["title"]=$module["title"];
	$update["short_title"]=$module["short_title"];
	$update["heading"]=$module["heading"];
	$update["status"]=$module["status"];
	$update["created_date"]=$module["created_date"];
	$update["nav_id"]=$module["nav_id"];
	$update["mod_time"]=$module["mod_time"];
	$update["mod_userid"]=$module["mod_userid"];
	$result=create_module_header($db,$db_table_prefix,$module["mod_userid"],$update);
	if ($result!==true){ return ($result); }
	
	//create the module instance
	$update=array();
	$update["page_id"]=$module["page_id"];
	$update["version_id"]=$module["version_id"];
	$update["body_text"]=$module["body_text"];
	$update["notes"]="NULL";
	$result=create_module($db,$db_table_prefix,$user_id,$update);
	if ($result!==true){ return ($result); }

	return (true);
}


function edit_module($db,$page,$module,$errors=NULL){

	/*
	$tbl=retrieve_tbls($db,$GLOBALS["CONFIG"]["db_common_prefix"]);
	$tbls=array();
	foreach ($tbl as $tbl_id => $values){ $tbls[$tbl_id]=$values["major"].".".$values["minor"]." ".$values["def"]; }
	*/
	//pre($tbls);
	//pre($module); exit();
	
	$editor_size=retrieve_editor_size($db,$GLOBALS["CONFIG"]["db_common_prefix"],$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"]);
	
	$b.="<table border='0'><tr><td>\n";
	$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='stronghold_module_text'>\n";
	$b.="<input type='hidden' name='module' value='text'>\n";
	$b.="<input type='hidden' name='page_id' value='".$page["page_id"]."'>\n";
	$b.="<input type='hidden' name='version_id' value='".$page["version_id"]."'>\n";
	$b.="<input type='hidden' name='stronghold_form' value='1'>\n";
	//$b.="<input type='hidden' name='action_hook' value=''>\n";

	$b.="<table border='0' class='dtable'>\n";
	$b.="<tr>\n";
	$b.="<th>Normal Title</th>\n";
	$tip="The full title of your document.";
	$b.="<td><input type='text' name='text_title' value='".$module["title"]."'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Short Title</th>\n";
	$tip="A short title (less than 20 characters). This is used on navigation menus and areas with limitted real-estate.";
	$b.="<td><input type='text' name='text_short_title' value='".$module["short_title"]."' maxlength='20'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	/*
	$b.="<tr>\n";
	$b.="<th>Category</th>\n";
	$tip="Triple Bottom Line Category. Please select the category that corresponds to the information in your document.";
	$b.="<td>".generic_select("tbl_id",$tbls,$module["tbl_id"]).tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	*/
	$b.="<tr>\n";
	$b.="<th>Heading</th>\n";
	$tip="Uncheck to turn the H1 heading off for this page.";
	$b.="<td><input type='checkbox' name='heading' value='1'"; if ($module["heading"]){ $b.=" checked"; } $b.="> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Auto-Nav</th>\n";
	$tip="Uncheck to turn off the automatically generated menus for this page.";
	$b.="<td><input type='checkbox' name='nav_id' value='1'"; if ($module["nav_id"]){ $b.=" checked"; } $b.="> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";	
	$b.="<tr><td colspan='2'>";

	//insert a new FCK Editor (you rock FCK!!!)
	include($_SERVER["DOCUMENT_ROOT"]."/includes/fck/fckeditor.php") ;
	$oFCKeditor = new FCKeditor('FCKeditor1') ;
	$oFCKeditor->BasePath = '/includes/fck/' ;
	$oFCKeditor->Width=$editor_size["width"];
	$oFCKeditor->Height=$editor_size["height"];
	$oFCKeditor->ToolbarSet="CMS";
	$oFCKeditor->Value=$module["body_text"];
	$b.=$oFCKeditor->CreateHtml() ;

	$b.="</td></tr>\n";
	
	//populate the publishing dates (sigh)
	if ($module["publish_live"]){
		$publish_live_date=date("d/m/Y",$module["publish_live"]);
		$publish_live_hour=date("H",$module["publish_live"]);
		$publish_live_min=date("i",$module["publish_live"]);
	} else {
		$publish_live_date=NULL;
		$publish_live_hour=NULL;
		$publish_live_min=NULL;
	}
	if ($module["publish_end"]){
		$publish_end_date=date("d/m/Y",$module["publish_end"]);
		$publish_end_hour=date("H",$module["publish_end"]);
		$publish_end_min=date("i",$module["publish_end"]);
	} else {
		$publish_end_date=NULL;
		$publish_end_hour=NULL;
		$publish_end_min=NULL;
	}
	
	$b.="<tr>\n";
	$b.="<th>Live Date</th>\n";
	$tip="If you would like to set a date other than today for this page to go live, you can specify it here. You DO NOT need to specify this if you would like it to go online immediately.";
	$b.="<td>".date_picker("publish_live_date",$publish_live_date)." <input type='text' name='publish_live_hour' value='".$publish_live_hour."' maxlength='2' size='4'>:<input type='text' name='publish_live_min' value='".$publish_live_min."' maxlength='2' size='4'> ".tooltip($tip)." <span class='footnote'>Optional - dd/mm/yy hh:mm</span></td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>End Date</th>\n";
	$tip="If you would like to set an expiry date for this document, you can specify it here. You do not need to specify an expiry date.";
	$b.="<td>".date_picker("publish_end_date",$publish_end_date)." <input type='text' name='publish_end_hour' value='".$publish_end_hour."' maxlength='2' size='4'>:<input type='text' name='publish_end_min' value='".$publish_end_min."' maxlength='2' size='4'> ".tooltip($tip)." <span class='footnote'>Optional - dd/mm/yy hh:mm</span></td>\n";
	$b.="</tr>\n";
	$b.="</table>\n";
	$b.="<br>\n";
	if (in_array($module["status"],array(1,2,4))){ $b.=button_submit("stronghold_module_text","update","Update","save.gif"); }
	if ($module["status"]==1){ $b.=button_submit("stronghold_module_text","approve","Submit for Approval","submit.gif"); }

	//foreach ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"] AS $gid => $value){ /* do nothing */ } //get the group id

	$b.="<br><br>\n";
	$b.=button_href("Return to Menu",prepare_str($_SERVER["PHP_SELF"]),"return.gif");
	//$b.="<input type='button' value='Return to Menu' onclick='window.location=\"".prepare_str($_SERVER["PHP_SELF"])."\"'>\n";

	$b.="<br><br>\n";
	$b.="<table border='1' class='dtable'>\n";
	$b.="<tr><th>Add Revision Note</th></tr>\n";
	$b.="<tr><td align='center'>\n";
	$b.="<textarea rows='6' cols='80' name='notes'></textarea><br>\n";
	$b.=button_submit("stronghold_module_text","append_note","Append Note","note.gif");
	$b.="<tr><th>Revision Notes</th></tr>\n";
	$b.="<tr><td>";
	if ($module["notes"]){ $b.=decode($module["notes"]); } else { $b.="<div align='center'><br><em>None.</em><br><br></div>\n"; }
	$b.="</td></tr>\n";
	$b.="</table>\n";
	$b.="</form>\n";
	
	$b.="</td><td>\n";
	$b.=box_approvals($db,$page,"text",$module["mod_time"]);
	$b.="</td></tr></table>";
	
	$head_title=$module["title"];
	$head_breadcrumbs=$page["parents"];
	$javascript["tooltip"]=1;
	
	$document=array();
	$document["body"]=$b;
	$javascript["tooltip"]=1;
	$javascript["submit_once"]=1;
	$javascript["date_chooser"]=1;
		
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
}

function post_module($db,$page,$module){
	
	//globals
	$db_table_prefix=$GLOBALS["CONFIG"]["db_table_prefix"];
	$db_common_prefix=$GLOBALS["CONFIG"]["db_common_prefix"];
	$user_id=$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"];

	//variable protection
	$page_id=prepare_int($_POST["page_id"]);
	$version_id=prepare_int($_POST["version_id"]);
	$title=prepare_str($_POST["text_title"]);
	$short_title=prepare_str($_POST["text_short_title"]);
	$heading=prepare_int($_POST["heading"]);
	$nav_id=prepare_int($_POST["nav_id"]);
	$notes=prepare_txt($_POST["notes"]);
	$publish_live_date=prepare_txt($_POST["publish_live_date"]);
	$publish_live_hour=prepare_int($_POST["publish_live_hour"]);
	$publish_live_min=prepare_int($_POST["publish_live_min"]);
	$publish_end_date=prepare_txt($_POST["publish_end_date"]);	
	$publish_end_hour=prepare_int($_POST["publish_end_hour"]);
	$publish_end_min=prepare_int($_POST["publish_end_min"]);
	
	$body_text=$_POST["FCKeditor1"]; //prepare_ strips too much, addslashes() escapes " as well as '
	//$body_text=str_replace("'","\'",$body_text); //addslashes() should be reviewed, for the moment just replace ' <- don't do this either
	
	if ($page_id==NULL){ fatal("No page specified."); }
	if ($version_id==NULL){ fatal("No version specified."); }
	if ($heading!=1){ $heading=0; }
	if ($nav_id!=1){ $nav_id=0; }

	if ($_POST["approve"]=="Approve"){ //direct compare, no no need for prepare_str
		if ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"]>1){ approve_module($db,$db_table_prefix,$page,$version_id); }
	} else {
	
		//error checking
		$errors=array(0,0);
		if ($title==NULL){ $errors[0]=1; }

		if (!in_array(1,$errors)){

			//retrieve the user
			$user=retrieve_user($db,$db_common_prefix,"user_id",$user_id);
			if (!$user){ fatal ("Could not load user information."); } 


			//add the revision notes
			if ($notes){
				$notes=rev_note($notes,$module["notes"],$user["firstname"]." ".$user["surname"]);
				log_edit($db,$db_table_prefix,$user_id,"REV_NOTE",$page_id,$version_id);
			}
		
			//update the header
			$update=array();
			$update["title"]=$title;
			$update["short_title"]=$short_title;
			$update["heading"]=$heading;
			$update["nav_id"]=$nav_id;
			$update["mod_time"]=time();
			$update["mod_userid"]=$user_id;
			$update["publish_live"]=date_timestamp($publish_live_date,$publish_live_hour,$publish_live_min);
			$update["publish_end"]=date_timestamp($publish_end_date,$publish_end_hour,$publish_end_min);
			//pre($update); exit();
			$result=update_module_header($db,$db_table_prefix,$page_id,$version_id,$update);
			//echo "!!!!!"; exit();
			if ($result!==true){ fatal($result); }
			
			//update the module
			$update=array();
			$update["body_text"]=$body_text;
			if ($notes){ $update["notes"]=$notes; } //only update the notes if they change
			$result=update_module($db,$db_table_prefix,$page_id,$version_id,$update);
			if ($result!==true){ fatal($result); }
			
			log_edit($db,$db_table_prefix,$user_id,"UPDATE",$page_id,$version_id);
		}
	}

	unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	header ("Location: ".$page["url"]."?version_id=".$page["version_id"]); exit(); //redirect the view of the page
	//edit_module($db,$page,$module);
}

//update a module, return true if OK, error if it fails
function update_module($db,$db_table_prefix,$page_id,$version_id,$module){
	//check for errors
	if ($page_id==NULL){ return ("Module Fault: No page id specified."); }
	if ($version_id==NULL){ return ("Module Fault: No version id specified."); }
	$result=field_check($module,array("body_text"),array("notes"),array(),"Module Fault");
	if ($result!==true){ return ($result); }
	
	//SQLize some of the variables
	$module["body_text"]="'".prepare_txt($module["body_text"])."'";
	if ($module["notes"]){ $module["notes"]="'".$module["notes"]."'"; }
	
	//do the update
	$sql="UPDATE ".$db_table_prefix."module_text SET ";
	$options=array();
	foreach ($module as $key => $value){ $options[]=$key."=".$value; }
	$sql.=implode(",",$options);
	$sql.=" WHERE page_id=".$page_id." AND version_id=".$version_id;
	
	//echo ($sql); exit();
	$db->query($sql);

	return (true);
}

function approve_module($db,$db_table_prefix,$page,$version_id){
	generic_approve_module($db,$db_table_prefix,$page,$version_id);
}

function lock_module($db,$db_table_prefix,$page_id,$version_id,$user_id){
	$user_id=generic_lock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	return ($user_id);
}

function unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id){
	generic_unlock_module($db,$db_table_prefix,$page_id,$version_id,$user_id);
	return (true);
}


function html_diff($string1,$string2){

	//$from_words = preg_split('/\b/',$string1);
	//$to_words = preg_split('/\b/',$string2);
	$from_words = explode("\n",$string1);
	$to_words = explode("\n",$string2);
	$mapped_from_words = $from_words;
	$mapped_to_words = $to_words;
	
	$diff=new Text_MappedDiff($from_words,$to_words,$mapped_from_words,$mapped_to_words);
	$difference = $diff->getDiff();
	
	
//print_r($difference);
	$r=''; // This will be the rendered difference.
	
	foreach ($difference as $op) {
		// You can tell which operation (add, delete or change) $op is by checking which class the object is
		if ($op instanceof Text_Diff_Op_copy){
			// text was unchanged
			$r.=implode('',$op->final); 
		} elseif (is_a($op,'Text_Diff_Op_delete')) {
			// text was deleted
			$r.='<span style="background-color: #FF0000;">' . implode('',$op->orig) . '</span>'; 
		} elseif (is_a($op,'Text_Diff_Op_add')) {
			// text was added
			$r.='<span style="background-color: #00FF00;">' . implode('',$op->final) . '</span>';
		} elseif (is_a($op,'Text_Diff_Op_change')) {
			// text was changed
			$r.='<span style="background-color: #FF0000;">' . implode('',$op->orig) . '</span>' . 
			'<span style="background-color: #00FF00;">' . implode('',$op->final) . '</span>';
		}
	}
	
	return ($r);
}
//-------------------------------------------------------------------------------------------------
// Deprecated code
?>