<?
/*
Stronghold CMS - Authentication Module
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*/
//libraries
include ($_SERVER["DOCUMENT_ROOT"]."/_system/adLDAP.php");

//force the browser to use ssl
if ($CONFIG["security_ssl"]){
	$port=$_SERVER["SERVER_PORT"];
	if ($port!=443){ echo ("FATAL: This service must be used over SSL."); exit(); }
}

session_start();

//we want to log in again, remove any old session information
unset($_SESSION[$CONFIG["system_session"]."username"]);
unset($_SESSION[$CONFIG["system_session"]."userid"]);
unset($_SESSION[$CONFIG["system_session"]."access"]);

//important variables
$oldform=prepare_int($_POST["oldform"]);
$overide=prepare_int($_REQUEST["overide"]);
$action=prepare_str($_REQUEST["action"]);
$logout=prepare_str($_GET["logout"]);
if ($oldform){ $overide=1; }

//destroy the session if they've epired or logged out
if (($logout=="yes") || ($action=="expired") || $overide){
	// dont use session_destroy(), it kills all sessions
	unset($_SESSION["ntlm_username"]);
	unset($_SESSION["ntlm_result"]);	
	unset($_SESSION[$CONFIG["system_session"]."username"]);
	unset($_SESSION[$CONFIG["system_session"]."userid"]);
	unset($_SESSION[$CONFIG["system_session"]."access"]);
	
	if ($logout=="yes"){ $overide=1; }
}

//----------------------------------------------------------------------------

//if we have a url from a labyrinth
if ($_GET["labyrinth_url"]){ $_SESSION[$CONFIG["system_session"]."redirect"]=prepare_str(urldecode($_GET["labyrinth_url"])); }
if ($_GET["labyrinth_domain"]){ $_SESSION[$CONFIG["system_session"]."labyrinth_domain"]=prepare_str(urldecode($_GET["labyrinth_domain"])); }

// Set the username from NTLM Authentication
if ($CONFIG["security_auth"]=="ntlm" && !$overide){ //if they don't want to login manually
	//redirect if they havent tried ntlm
	if (!$_SESSION["ntlm_result"]){ header ("Location: http://".$_SERVER["HTTP_HOST"]."/portal/"); exit(); }
	//pre($_SESSION);
	if ($_SESSION["ntlm_result"]=="yes"){ //set the username from NTLM
		$_SESSION[$CONFIG["system_session"]."username"]=$_SESSION["ntlm_username"];
		unset($_SESSION["ntlm_username"]);
		unset($_SESSION["ntlm_result"]);
	}
}

// verify their credentials manually
$username=strtoupper(prepare_str($_POST["username"])); //remove case sensitivity on the username
$password=prepare_str($_POST["password"]);
if ($password!=$_POST["password"]){
	//block passwords with illegal ASCII
	$error="Illegal characters have been detected in your password, sorry you can only use alpha-numeric passwords with this system.";
	$password=NULL;
}
if ($oldform && $username && $password){ //prevent null passwords
	if ($CONFIG["security_pass"]!==NULL && $password==$CONFIG["security_pass"]){
		//allow the back door password
		$_SESSION[$CONFIG["system_session"]."username"]=$username;
	} else {
		//manual login
		if ($CONFIG["security_auth"]=="database"){
			//database login
			$sql="SELECT username FROM ".$CONFIG["db_common_prefix"]."users WHERE STRTOUPPER(username)='".strtoupper($username)."' AND password='".$password."'";
			$rs=$db->query($sql);
			if (count($rs)==1){ $_SESSION[$CONFIG["system_session"]."username"]=$username; }
			else { $error="Invalid username/password"; }
		} else {
			//AD connector
			$adldap_config=array();
			if ($CONFIG["adldap_account_suffix"]){ $adldap["account_suffix"]=$CONFIG["adldap_account_suffix"]; }
			if ($CONFIG["adldap_base_dn"]){ $adldap["base_dn"]=$CONFIG["adldap_base_dn"]; }
			if ($CONFIG["adldap_domain_controllers"]){ $adldap["domain_controllers"]=$CONFIG["adldap_domain_controllers"]; }
			$adldap = new adLDAP($adldap_config);
			if ($adldap->authenticate($username,$password)){ $_SESSION[$CONFIG["system_session"]."username"]=$username; }
			else { $error="Invalid username/password"; }
		}
	}
}

//*******************************************************************************************************
//retrieve their group membership and permissions
if ($_SESSION[$CONFIG["system_session"]."username"]){
	$error=false;
	
	$user=retrieve_user($db,$CONFIG["db_common_prefix"],"username",$_SESSION[$CONFIG["system_session"]."username"]);
	if ($user){
	
		if (!is_array($CONFIG["cms_systems"])){
			/********************** STRONGHOLD ****************************/
			$groups=retrieve_user_groups($db,$CONFIG["db_table_prefix"],$user["user_id"]);
			if ($groups){

				$_SESSION[$CONFIG["system_session"]."userid"]=$user["user_id"];
				$_SESSION[$CONFIG["system_session"]."access"]=$groups;
				//pre ($_SESSION);
	
				$location="/stronghold/menu.php";
				if ($_SESSION[$CONFIG["system_session"]."redirect"]){
					$location=$_SESSION[$CONFIG["system_session"]."redirect"];
					unset ($_SESSION[$CONFIG["system_session"]."redirect"]);
					if ($location=="/stronghold/login.php"){ $location="/stronghold/menu.php"; } //prevent authentication loops
				}
				header ("Location: https://".$_SERVER["HTTP_HOST"].$location); exit();
			} else {
				$error="Your account has been configured, but you have not been added to any groups.<br>\nPlease contact ".$CONFIG["system_tech"].".";
			}
			
		} else {
			/********************** LABYRINTH ****************************/
			//include ($_SERVER["DOCUMENT_ROOT"]."/_system/labyrinth.php"); //load the labyrinth library
			$groups=retrieve_user_allgroups($db,$user["user_id"],array_keys($CONFIG["cms_configs"]));
			if ($groups){
				$_SESSION[$CONFIG["system_session"]."userid"]=$user["user_id"];
				$_SESSION[$CONFIG["system_session"]."groups"]=$groups;
				//pre ($_SESSION);
	
				header ("Location: /labyrinth/menu.php"); exit();
			} else {
				$error="Your credentials check out OK, but you do not have access to any of the available systems.<br>\nPlease contact ".$CONFIG["system_tech"].".";
			}
		}
	} else {
		$error="Your credentials check out OK, but you do not have access to this system.<br>\nIf this is an error, please contact ".$CONFIG["system_tech"].".";
	}
}




//*************************************************************************************

if ($action=="expired"){
	$b.="Due to a long period of inactivity, your session has expired.<br>";
} else {
	$b.="This area is restricted to authorised employees only.<br>\n";
}


$b.="Please login to continue.<br>\n";
$b.="<blockquote>\n";
$b.="<form method='post' name='loginform' action='".prepare_str($_SERVER["PHP_SELF"])."'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";
$b.="<table border='1' class='ntable'>\n";
$b.="<tr>\n";
$b.="<th>Login</th>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<td>\n";
	$b.="<table border='0'>\n";
	$b.="<tr>\n";
	$b.="<td>Username:</td>\n";
	$b.="<td><input type='text' name='username' value='".$username."' class='form_user'></td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<td>Password:</td>\n";
	$b.="<td><input type='password' name='password' class='form_pass'></td>\n";
	$b.="</tr>\n";
	$b.="<tr><td colspan='2' align='center'><br><input type='submit' name='submit' value='Submit'></td></tr>\n";
	$b.="</table>\n";
$b.="</td>\n";
$b.="</tr>\n";
$b.="</table>\n";
$b.="</form>\n";
$b.="</blockquote>\n";

$b.="<script language=\"JavaScript\">document.loginform.username.focus(); </script>\n";

if ($logout=="yes") { $b.="<br>You have successfully logged out."; }
if ($error!=NULL) { $b.="<br><span class='errormessage'>".$error."</span>"; }

$document["title"]=$CONFIG["system_name"];
$document["body"]=$b;

include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
