<?
/*
Stronghold CMS - Error Handler
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.


Dynamically load javascript on demand
*/

//error_reporting(0);
//error_reporting(E_ALL ^ E_NOTICE);

//ini_set('display_errors', 'Off');
//ini_set('log_errors', 'On');
//define('ERROR_LOG_PATH', '/tmp/error_log.txt'); // The path to the error log file

// set to the user defined error handler
//set_error_handler("custom_err_handler");
//set_error_handler("userErrorHandler");


// user defined error handling function
function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars){

    // timestamp for the error entry
    $dt = date("Y-m-d H:i:s (T)");

    // define an assoc array of error string
    // in reality the only entries we should
    // consider are E_WARNING, E_NOTICE, E_USER_ERROR,
    // E_USER_WARNING and E_USER_NOTICE
    $errortype = array (
                E_ERROR              => 'Error',
                E_WARNING            => 'Warning',
                E_PARSE              => 'Parsing Error',
                E_NOTICE             => 'Notice',
                E_CORE_ERROR         => 'Core Error',
                E_CORE_WARNING       => 'Core Warning',
                E_COMPILE_ERROR      => 'Compile Error',
                E_COMPILE_WARNING    => 'Compile Warning',
                E_USER_ERROR         => 'User Error',
                E_USER_WARNING       => 'User Warning',
                E_USER_NOTICE        => 'User Notice',
                E_STRICT             => 'Runtime Notice',
                E_RECOVERABLE_ERROR  => 'Catchable Fatal Error'
                );
				
    // set of errors for which a var trace will be saved
    $user_errors = array(E_USER_ERROR, E_USER_WARNING, E_USER_NOTICE);
    
    $err = "<errorentry>\n";
    $err .= "\t<datetime>" . $dt . "</datetime>\n";
    $err .= "\t<errornum>" . $errno . "</errornum>\n";
    $err .= "\t<errortype>" . $errortype[$errno] . "</errortype>\n";
    $err .= "\t<errormsg>" . $errmsg . "</errormsg>\n";
    $err .= "\t<scriptname>" . $filename . "</scriptname>\n";
    $err .= "\t<scriptlinenum>" . $linenum . "</scriptlinenum>\n";
    if (in_array($errno, $user_errors)) { $err .= "\t<vartrace>".wddx_serialize_value($vars, "Variables")."</vartrace>\n"; }
    $err .= "</errorentry>\n\n";
    
	//error_log($err, 3, "/tmp/php-error.log");
//echo (E_STRICT);
	$dont_care=array(E_NOTICE,E_STRICT);
//echo $errno."<br>";

	if (!in_array($errno,$dont_care)){
		//echo ("An error has occured.");
		//echo ($err);
		//if ($errno!=2048){
		//mail("webmaster@localhost", "Critical User Error", $err);
		//exit ();
	}
}


?>
