<?
/*
Stronghold CMS - HTTP request handler
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

//figure out the url
$url=prepare_str($_SERVER["SCRIPT_URL"]);
$q_loc=strpos($url,"?");
if ($q_loc){ $url=substr($url,0,$q_loc); } //trim off the variables

// figure out the mode - view, edit, post
$mode="view";
if ((int)prepare_int($_POST["stronghold_form"])===1){ $mode="post"; }
if ($_GET["mode"]=="edit"){ $mode="edit"; } //direct comparison, no need for prepare_str

//echo ($mode); exit();
//if we have a trailing slash, redirect to /index
if ($url[strlen($url)-1]=="/"){
	header("HTTP/1.1 301 Moved Permanently");
	header("Location: ".$protocol."://".$_SERVER["HTTP_HOST"].$url."index");
	exit();
} 

$page_data=load_page($db,$url);
//print_r($page_data);
//exit();

if (is_array($page_data)){
	//document has been found
	$page=$page_data["page"];
	$module=$page_data["module"];
	
	header("Expires: Mon, 8 Jun 1995 05:00:00 GMT"); // Any date in the past, why not the day PHP was released :D
	header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
	header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache"); // HTTP/1.0

	if ($mode=="view"){ view_page($db,$page,$module); }
	elseif ($mode=="edit"){ edit_page($db,$page,$module); }
	elseif ($mode=="post"){ post_page($db,$page,$module); }
	
} else {
	if ($page_data==404){
		//echo "Not found";
		header("HTTP/1.0 404 Not Found");
		$head_heading=$head_title;
		$last_modified=time();

		$document=array();
		$document["title"]="Document Not Found!";
		$document["body"]=file_get_contents($_SERVER["DOCUMENT_ROOT"]."/_error/404.htm");
		include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
		
	} elseif ($page_data==301){
		header("HTTP/1.1 301 Moved Permanently");
		header("Location: ".$protocol."://".$_SERVER["HTTP_HOST"].$url."/index");
	} else {
		fatal ("Handler Fault: Unknown return value - ".$page_data);
	}
}
?>
