<?
/*
Stronghold CMS - Apache Configuration Generator
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

function apache_http_config($ip,$email,$doc_root,$host,$log_prefix){

return ("
<VirtualHost *>
    ServerAdmin ".$email."
    DocumentRoot ".$doc_root."
    ServerName ".$host."
    ErrorLog /var/log/apache2/".$log_prefix."error_log
    CustomLog /var/log/apache2/".$log_prefix."access_log combined

	<Directory ".$doc_root.">
		Options Indexes FollowSymLinks MultiViews
		AllowOverride None
		Order allow,deny
		allow from all
	</Directory>

    <Directory \"".$doc_root."/portal\">
        AuthName \"NTLM Authentication\"
        NTLMAuth on
        NTLMAuthHelper \"/usr/bin/ntlm_auth --helper-protocol=squid-2.5-ntlmssp\"
        NTLMBasicAuthoritative on
        AuthType NTLM
        require valid-user
    </Directory>

    RewriteEngine on
    RewriteRule ^/resources/(.*)$ /stronghold/fetch.php?request=$1 [L]
    RewriteCond %{REQUEST_URI} !^/portal
    RewriteCond %{REQUEST_URI} !^/includes
    RewriteRule ^(.*)$ /_system/handler.php
</VirtualHost>");
}

function apache_ssl_config($ip,$email,$doc_root,$host,$log_prefix){

return("
<VirtualHost ".$ip.":443>

	DocumentRoot \"".$doc_root."\"
	ServerName ".$host."
	ServerAdmin ".$email."
	ErrorLog /var/log/apache2/".$log_prefix."ssl_error_log
	TransferLog /var/log/apache2/".$log_prefix."ssl_access_log

	<Directory ".$doc_root.">
		Options Indexes FollowSymLinks MultiViews
		AllowOverride None
		Order allow,deny
		allow from all
	</Directory>

	Alias /phpPgAdmin /opt/phpPgAdmin
	<Directory /opt/phpPgAdmin>
		Options Indexes FollowSymLinks MultiViews
		AllowOverride None
		Order allow,deny
		allow from all

		AuthName Restricted
		AuthType Basic
		AuthUserFile /etc/apache2/htpasswd
		Require valid-user
	</Directory>

	SSLEngine on
	SSLCipherSuite ALL:!ADH:!EXPORT56:RC4+RSA:+HIGH:+MEDIUM:+LOW:+SSLv2:+EXP:+eNULL
	SSLCertificateFile /etc/apache2/ssl/".$host.".crt
	SSLCertificateKeyFile /etc/apache2/ssl/".$host.".key
	#SSLCertificateChainFile /etc/apache2/ssl/ca.crt
	
	<Files ~ \"\.(cgi|shtml|phtml|php3?)$\">
		SSLOptions +StdEnvVars
	</Files>
	<Directory \"/usr/local/apache2/cgi-bin\">
		SSLOptions +StdEnvVars
	</Directory>
	
	SetEnvIf User-Agent \".*MSIE.*\" \
			 nokeepalive ssl-unclean-shutdown \
			 downgrade-1.0 force-response-1.0
	
	CustomLog /var/log/apache2/ssl_request_log \
			  \"%t %h %{SSL_PROTOCOL}x %{SSL_CIPHER}x \\\"%r\\\" %b\"

	RewriteEngine on
	RewriteRule ^/resources/(.*)$ /stronghold/fetch.php?request=$1 [L]
	RewriteCond %{REQUEST_URI} !^/resources
	RewriteCond %{REQUEST_URI} !^/includes
	RewriteCond %{REQUEST_URI} !^/stronghold
	RewriteCond %{REQUEST_URI} !^/phpPgAdmin
	RewriteRule ^(.*)$ /_system/handler.php

</VirtualHost>
");
}

?>