<?
/*
Stronghold CMS - Permissions Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/extended.php");

$group_id=NULL; //we need to reset the group_id variable if we want to use it

$db_table_prefix=$CONFIG["db_table_prefix"];

if ($_POST["oldform"]){ //have a submitted form (direct compare, no need for prepare_)
	$user_id=prepare_int($_POST["user_id"]);
	$group_id=prepare_int($_POST["group_id"]);
	$level=prepare_int($_POST["level"]);
	
	$error=array();
	if ($user_id==NULL){ $error["user_id"]="<span class='errormessage'>Please select a user</span><br>\n"; }
	if ($group_id==NULL){ $error["group_id"]="<span class='errormessage'>Please select a group</span><br>\n"; }
	if ($level==NULL){ $error["level"]="<span class='errormessage'>Please select a permission level</span><br>\n"; }
	
	if ($user_id!=NULL && $group_id!=NULL){
	
		$sql="SELECT user_id FROM ".$db_table_prefix."group_members WHERE group_id=".$group_id." AND user_id=".$user_id;
		$rs=$db->query($sql);
		//echo (ptable($rs));
		if (count($rs)==1){
			$error["general"]="<span class='errormessage'>Cannot add new entry, it already exists.</span><br>\n";
		} else {		
			$sql="INSERT INTO ".$db_table_prefix."group_members (group_id,user_id,level) VALUES (".$group_id.",".$user_id.",".$level.")";
			$db->query($sql);
			//inserted ok, reset the variables
			$user_id=NULL;
			$group_id=NULL;
			$level=NULL;
		}
	}
	
	foreach ($_POST as $key => $value){ //prepare_int done in the sql syntax
		if ($value=="Remove" && substr($key,0,7)=="remove_"){
			$vals=explode("_",$key);
			$gid=prepare_int($vals[1]);
			$uid=prepare_int($vals[2]);
			if ($gid && $uid){
				$sql="DELETE FROM ".$db_table_prefix."group_members WHERE group_id=".$gid." AND user_id=".$uid;
				//echo ($sql);
				$db->query($sql);
			}
		}
	}
}

// load the data objects
$aclevels=retrieve_useraccess($db,$CONFIG["db_common_prefix"]);
$groups=retrieve_groups($db,$db_table_prefix);
$users=retrieve_users($db,$CONFIG["db_common_prefix"]);

//transform the users into something we can pump into a generic select
$user_select=array();
foreach ($users as $uid => $values){ $user_select[$uid]=$values["surname"].", ".$values["firstname"]; }
//pre($users); exit();

// MEMBERSHIP
$membership=array();
foreach ($groups as $gid => $title){ $membership[$gid]=array(); } //initialise the array
$sql="SELECT * FROM ".$db_table_prefix."group_members";
$rs=$db->query($sql);
foreach ($rs as $id => $r){
	$gid=$r["group_id"];
	unset($r["group_id"]);
	$membership[$gid][]=$r;
}
//pre($membership);

//----------------------------------------------------------------------------------------------------------------------
$b.=button_href("Return to Menu","menu.php","return.gif");
$b.=button_href("Update Groups","groups.php","groups.gif");

$b.="<br><br>\n";
$b.=$error["general"];
$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='group_members' id='group_members'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";

$b.="<table border='1' class='dtable'>\n";
$b.="<tr><th>New Relationship</th></tr>\n";
$b.="<tr><td>\n";
	$b.="<table border='0' class='dtable'>\n";
	$b.="<tr>\n";
	$b.="<td class='dtitle'>User:</td>\n";
	$b.="<td>".generic_select("user_id",$user_select,$user_id)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<td class='dtitle'>Group:</td>\n";
	$b.="<td>".generic_select("group_id",$groups,$group_id)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<td class='dtitle'>Access:</td>\n";
	$b.="<td>".generic_select("level",$aclevels,$level)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr><td colspan='2' align='center'><br>".button_submit("group_members","create","Create","save.gif")."</td></tr>\n";
	$b.="</table>\n";
$b.="</td></tr>\n";
$b.="</table><br>\n";

// --------------------------------------------------------------------------------

$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Group</th>\n";
$b.="<th>Users</th>\n";
$b.="</tr>\n";

foreach ($groups AS $gid => $title){
		$b.="<tr>\n";
		$b.="<td>".$title."</td>\n";
		$b.="<td>";
			$b.="<table border='0' class='dtable' width='100%' cellspacing='0' cellpadding='2'>\n";
			foreach ($membership[$gid] AS $id => $values){ 
				$user=$users[$values["user_id"]];
				$b.="<tr>\n";
				$b.="<td width='90%'>".$user["surname"].", ".$user["firstname"]." <span class='footnote'>(".$aclevels[$values["level"]].")</span></td>\n";
				//$b.="<td width='10%'><input type='submit' value='Remove' name='remove_".$gid."_".$values["user_id"]."'></td>\n";
				$b.="<td width='10%'>".button_submit("group_members","remove_".$gid."_".$values["user_id"],"Remove","archive.gif")."</td>\n";
				$b.="</tr>\n";
			}
			$b.="</table>\n";
		$b.="</td>\n";
		$b.="</tr>\n";
}
$b.="</table>\n";
$b.="<br>";

$b.="</form>";

$document=array();
$document["title"]="Group Membership";
$document["body"]=$b;

include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
