<?
/*
Stronghold CMS - Main Menu
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

/*
FIRST MENU
- shows all content that has a rating of "pending"
- highlights in red the rows that "need your attention" ie. need to be approved by your business unit
- displays both pages and resources

SECOND MENU
- shows a complete list of all pages on the site
- any page that has ANY version not approved or cancelled highlighted in yellow
*/

//pre($_SESSION);
$db_table_prefix=$GLOBALS["CONFIG"]["db_table_prefix"];

// GROUPS
$groups=retrieve_groups($db,$db_table_prefix);
$workflows=retrieve_workflows($db,$db_table_prefix);

$pending=array();

// PAGES (that aren't approved)
$sql="SELECT m.page_id,m.version_id,m.title,m.mod_time,p.url,p.workflow_id".
	" FROM ".$db_table_prefix."module AS m".
	" LEFT JOIN ".$db_table_prefix."pages AS p ON m.page_id=p.page_id".
	" WHERE status=2".
	" AND p.archive_date IS NULL".
	" ORDER BY p.levels,p.url ASC";
$rs=$db->query($sql);
//map them to the array
foreach ($rs as $id => $r){
	$key="p".".".$r["page_id"].".".$r["version_id"];
	$pending[$key]=array(
		"title"=>$r["title"],
		"modified"=>$r["mod_time"],
		"workflow_id"=>$r["workflow_id"],
		"link_label"=>$r["url"],
		"link_href"=>$r["url"]."?version_id=".$r["version_id"],
	);
}


// RESOURCES (that aren't approved)
$sql="SELECT v.resource_id,v.version_id,v.node_id,".tree_path_sql($GLOBALS["CONFIG"]["db_type"],$db_table_prefix,"v.node_id")." AS path,v.file_type,v.filename,v.time_created,r.workflow_id".
	" FROM ".$db_table_prefix."resource_versions AS v,".$db_table_prefix."resources AS r".
	" WHERE status=1".
	" AND archive_date IS NULL".
	" AND v.resource_id=r.resource_id";
$rs=$db->query($sql);
//echo ptable($rs);
//map them to the array
foreach ($rs as $id => $r){
	$key="r".".".$r["resource_id"].".".$r["version_id"];
	$pending[$key]=array(
//		"title"=>$r["filename"],
		"modified"=>$r["time_created"],
		"workflow_id"=>$r["workflow_id"],
		"link_label"=>$r["path"]."/".$r["filename"],
		"link_href"=>"/stronghold/resources/index.php?resource_id=".$r["resource_id"],
	);
}


//pre($pending); exit();

$workflow_cache=array();

$b.="<table border='0'>\n";
$b.="<tr><td width='99%'>\n";


$b.="<h2>Pending Content</h2>";
$b.="<table border='1' class='dtable' width='90%'>\n";
$b.="<tr>\n";
//$b.="<th width='20%'>URL</th>\n";
$b.="<th width='1%'>ID</th>\n";
$b.="<th width='75%'>Page</th>\n";
$b.="<th width='23%'>Approvals</th>\n";
$b.="<th width='1%'>Modified</th>\n";
$b.="</tr>\n";
foreach ($pending as $id => $r){

	$bits=explode(".",$id); //break up the key	

	if ($bits[0]=="p"){
		$approvals=retrieve_page_approvals($db,$db_table_prefix,$bits[1],$bits[2]);
		$label="Page";
	} elseif ($bits[0]=="r"){
		$approvals=retrieve_resource_approvals($db,$db_table_prefix,$bits[1],$bits[2]);
		$label="Resource";
	} else {
		fatal ("Resource Menu Fault: Undefined resource type");
	}

	$workflow=$workflows[$r["workflow_id"]];

	$highlight=NULL;
	foreach ($_SESSION[$CONFIG["system_session"]."access"] as $group_id => $level){
		//if (! is_approved($workflow["workflows"],$workflow["approvals"],$group_id)){ $highlight=" bgcolor='#996666'"; }
		if (in_array($group_id,$workflow)){ //if this page requires approval from their group
			if (!in_array($group_id,$approvals)){ $highlight=" class='attention'"; } //if they haven't approved it
		}
	}

	$b.="<tr".$highlight.">\n";
	$b.="<td>".$label."<br>\n".$bits[1].".".$bits[2]."</td>\n";
	$b.="<td>".decode($r["title"])."<br><a href='".$r["link_href"]."'>".$r["link_label"]."</a></td>\n";
	$b.="<td>";
	foreach ($workflow as $id => $group_id){
		if (in_array($group_id,$approvals)){ $class="approved"; } else { $class="not_approved"; }
		$b.="<nobr><span class='".$class."'>".$groups[$group_id]."</span></nobr><br>\n";
	}
	$b.="</td>\n";
	$b.="<td><nobr>".date("d/m/Y H:i",$r["modified"])."</nobr></td>\n";
	$b.="</tr>\n";
}

if (count($pending)==0){ $b.="<tr><td colspan='4' align='center'><em><br>No pages pending approval.<br><br></em></td></tr>\n"; }
$b.="</table>\n";

$b.="<br><br>\n";

//find all the pages that have unapproved modules
$not_approved=array();
$sql="SELECT DISTINCT page_id FROM ".$db_table_prefix."module WHERE status=2 OR status=1";
$rs=$db->query($sql);
foreach ($rs as $id =>$r){ $not_approved[]=$r["page_id"]; }
//pre($not_approved);

//find all pages that don't have an approved module
$sql="SELECT page_id FROM ".$db_table_prefix."pages WHERE
page_id NOT IN (SELECT DISTINCT page_id FROM ".$db_table_prefix."module WHERE status=3)";
$rs=$db->query($sql);
foreach ($rs as $id =>$r){ $not_approved[]=$r["page_id"]; }
$not_approved=array_unique($not_approved);

//retrieve all the pages
$sql="SELECT p.page_id,p.url,p.time_created,m.module_name
FROM ".$db_table_prefix."pages AS p, ".$db_table_prefix."modules AS m
WHERE p.module_id=m.module_id
AND p.archive_date IS NULL
ORDER BY url ASC";
$rs=$db->query($sql);
//echo ptable($rs);

$b.="<h2>Website Overview</h2>";

//echo ptable($rs);
$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>ID</th>\n";
$b.="<th>Link</th>\n";
$b.="<th>Type</th>\n";
$b.="</tr>\n";

foreach ($rs as $id => $r){
	$b.="<tr"; if (in_array($r["page_id"],$not_approved)){ $b.=" class='warning'"; } $b.=">\n";
	$b.="<td>".$r["page_id"]."</td>\n";
	$b.="<td><a href='".$r["url"]."'>".$r["url"]."</a></td>\n";
	$b.="<td>".$r["module_name"]."</td>\n";
	$b.="</tr>\n";
}
$b.="</table>\n";

$b.="</td><td>\n";



//administrator options
if (has_admin($_SESSION[$CONFIG["system_session"]."access"])){ //if they're an administrator
	$buttons.=button_href("Users","users.php","user.gif")."<br>\n";
	//$buttons.=button_href("Edit Users","users.php","user.gif")."<br>\n";
	$buttons.=button_href("Groups","membership.php","groups.gif")."<br>\n";
	//$buttons.=button_href("Permissions","permissions.php","permissions.gif")."<br>\n";
	$buttons.=button_href("Workflows","workflows.php","workflows.gif")."<br>\n";
	$b.=menu_box("Administration",$buttons);
}

//general options
$buttons=button_href("New Page","newpage.php","new_page.gif");
$buttons.=button_href("Resources","resources/index.php?node_id=1","resources.gif");
if ($_SESSION[$CONFIG["system_session"]."labyrinth_domain"]){ $buttons.=button_href("Labyrinth","https://".urldecode($_SESSION[$CONFIG["system_session"]."labyrinth_domain"]),"labyrinth.gif"); }
$buttons.=button_href("Logout","/stronghold/login.php?logout=yes","logout.gif");
$b.=menu_box("General",$buttons);

$b.="</td></tr></table>\n";


$document=array();
$document["body"]=$b;
$document["title"]="Stronghold CMS Main Menu";
$javascript["go"]=1;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");

?>