<?
/*
Stronghold CMS - New Page Creation
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

$create_result=true;

$oldform=prepare_int($_POST["oldform"]);

if ($oldform){
	$link=prepare_str(stripslashes($_POST["link"]));
	$module_id=prepare_int($_POST["module_id"]);
	$normal_title=prepare_str($_POST["normal_title"]);
	$short_title=prepare_str($_POST["short_title"]);
	$parent=prepare_int($_POST["parent"]);
	$workflow=prepare_int($_POST["workflow"]);
	
	$err=array(0,0,0,0,0,0);
	if ($link==NULL){ $err[0]=1; }
	if ($module_id==NULL){ $err[1]=1; }
	if ($normal_title==NULL){ $err[2]=1; }
	if ($short_title==NULL){ $err[6]=1; }
	if ($parent==NULL){ $err[3]=1; }
	if ($workflow==NULL){ $err[4]=1; }
	if (illegal_link($link)){ $err[5]=1; }
	
	
	if (!in_array(1,$err)){
		//$link=strtolower($link); //we only want lowercase links or the urls get ugly
		$now=time();
	
		$page["time_created"]=$now;
		$page["parent"]=$parent;
		$page["workflow_id"]=$workflow;
		$page["link"]=$link;
		//$page["url"]=NULL; //url is calculated by create_page()
		$page["module_id"]=$module_id;
		$page["archive_date"]=NULL;
		//$page["levels"]=NULL; //levels is calculated by create_page()
		//$module["page_id"]=NULL; //page_id is calculated by create_page()
		$page["title"]=$normal_title;
		$page["short_title"]=$short_title;

		//load the module type
		$module_name=retrieve_module_name($db,$GLOBALS["CONFIG"]["db_table_prefix"],$module_id);
		if (!$module_name){ fatal("Page Creation Fault - Undefined module type."); }
		$include_path=$_SERVER["DOCUMENT_ROOT"]."/_modules/".$module_name.".php";
		if (!file_exists($include_path)){ fatal("Page Creation Fault - Could not locate module \"".$module_name."\""); } //check it exists
		include ($include_path); //load the module
		
		//create the page (pass $page by reference)
		$create_result=create_page($db,$GLOBALS["CONFIG"]["db_table_prefix"],$_SESSION[$GLOBALS["CONFIG"]["system_session"]."userid"],$page);
		//$redirect=substr($page["url"],1,strlen($page["url"])-2); //remove the '' marks from the url string
		$redirect=$page["url"]; //revisit this, maybe it can be done a bit better

		if ($create_result===true && $redirect){ header ("Location: ".$redirect."?mode=edit&version_id=1"); exit(); }
	}
}

//******************************************************************************************

$groups=retrieve_groups($db,$CONFIG["db_table_prefix"]);
$workflows=array();
$temp=retrieve_workflows($db,$CONFIG["db_table_prefix"]);
foreach ($temp as $workflow_id => $values){
	$temp_groups=array();
	foreach ($values as $id => $group_id){ $temp_groups[]=$groups[$group_id]; }
	$workflows[$workflow_id]=$workflow_id.". ".implode(" - ",$temp_groups);
}


$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";
$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Link</th>\n";
$tip="The text to use in the URL bar. The link cannot contain spaces. eg. if you are adding the page &quot;/topic/subtopic/subsubtopic&quot;, the link will be &quot;subsubtopic&quot;";
$b.="<td><nobr><input type='text' name='link' value='".$link."'> ".tooltip($tip);
if ($err[0]){ $b.=" <span class='errormessage'>Please enter a link.</span>"; }
if ($err[5]){ $b.=" <span class='errormessage'>Link must only contain alpha-numeric chars, lowercase, no spaces.</span>"; }
$b.="</nobr></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Module</th>\n";
$tip="The type of module you are adding. If unsure, use &quotGeneric Text Module&quot";
$b.="<td>".select_box(retrieve_modules($db,$CONFIG["db_table_prefix"]),"module_id",1).tooltip($tip)."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th><nobr>Full Title</nobr></th>\n";
$tip="The full title of your page.";
$b.="<td><nobr><input type='text' name='normal_title' value='".$normal_title."' size='40' maxlength='255'> ".tooltip($tip);
if ($err[2]){ $b.=" <span class='errormessage'>Please enter a title.</span>"; }
$b.="</nobr></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th><nobr>Short Title</nobr></th>\n";
$tip="Some areas of a website like navigation bars have limited real estate. Long links can push other things off the page, this short title is used in these areas. Your navigation link must be less than 20 characters.";
$b.="<td><input type='text' name='short_title' value='".$short_title."' maxlength='20'> ".tooltip($tip)." <span class='footnote'>(short)</span>";
if ($err[6]){ $b.=" <span class='errormessage'>Please enter a short title.</span>"; }
$b.="</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Parent</th>\n";
$tip="This is the parent page of the page you are adding. Where in the logical structure of the website would you like to add your page?";
$b.="<td>".select_box(retrieve_pages($db,$CONFIG["db_table_prefix"]),"parent",NULL).tooltip($tip)."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Workflow</th>\n";
$tip="The workflow of a page is the approval process it needs to go through before it can go online.";
$b.="<td>".select_box($workflows,"workflow",1).tooltip($tip)."</td>\n";
$b.="</tr>\n";
$b.="</table>\n";

$b.="<br>\n";
$b.="<input type='submit' name='submit' value='Create'><br><br>";
//$b.="<input type='button' value='Return to Menu' onclick='window.location=\"menu.php\"'>\n";
$b.=button_href("Return to Menu","menu.php","return.gif");
$b.="</form>\n";

$b.="<br>\n";

if ($create_result!==true){ $b.="<span class='errormessage'>".$create_result."</span>\n"; }
//$b.="<input type='button' value='New Page' onclick='window.location=\"newpage.php\"'><br>\n";


$javascript["tooltip"]=1;
$document=array();
$document["title"]="Create Page";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
?>
