<?
/*
Stronghold CMS - Resource File Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

------------------------------------------------------------------

The file upload interaction on this script makes it overly
complicated. This is probably the most likely thing in the
system to give you a headache (it certainly gave me one).

*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");
$resource=new resource($db,$CONFIG["db_table_prefix"]);

$oldform=prepare_int($_POST["oldform"]);

//load the resource id
$resource_id=request_key("resource_id");
if ($resource_id==NULL){ fatal("Resource File Manager Fault - No resource id specified"); }
$node_id=prepare_int($_GET["node_id"]);
if ($node_id==NULL){ $node_id=prepare_int($_POST["node_id"]); }

// approve a resource
if ($_GET["approve"]==1){ //direct compare, no need for prepare_int()
	$version_id=prepare_int($_GET["version_id"]);
	if ($version_id==NULL){ fatal("Resource File Manager Fault - No version_id specified for approving resource"); }
	if ($resource_id=="new"){ fatal("Resource File Manager Fault - Illegal value for approving resource_id"); }
	$result=$resource->approve($resource_id,$version_id);
	if ($result){ header ("Location: menu.php?resource_id=".$resource_id); exit(); }
	else { fatal("Resource File Manager Fault - Approving resource failed"); }
}

// cancel a resource
if ($_GET["cancel"]==1){ //direct compare, no need for prepare_int()
	$version_id=prepare_int($_GET["version_id"]);
	if ($version_id==NULL){ fatal("Resource File Manager Fault - No version_id specified for cancelling resource"); }
	if ($resource_id=="new"){ fatal("Resource File Manager Fault - Illegal value for cancelling resource_id"); }
	$result=$resource->cancel($resource_id,$version_id);
	if ($result){ header ("Location: menu.php?resource_id=".$resource_id); exit(); }
	else { fatal("Resource File Manager Fault - Cancelling resource failed"); }
}

// archive a resource
if ($_GET["archive"]==1){ //direct compare, no need for prepare_int()
	$resource_id=prepare_int($_GET["resource_id"]);
	if (!$resource_id){ fatal("No resource_id specified for archive resource"); }

	//load the resource	
	$r=$resource->retrieve($resource_id);
	if (!$r){ fatal ("Could not locate resource to achive"); }
	
	//set it to archived
	$sql="UPDATE ".$CONFIG["db_table_prefix"]."resources SET archive_date=".time()." WHERE resource_id=".$resource_id;
	$db->query($sql);
	
	//redirect to the folder the resource was in
	header ("Location: menu.php?node_id=".$r["versions"][$r["current_version"]]["node_id"]); exit();
}


//process a form submission
if ($oldform){
	$version_id=request_key("version_id");
	$filename=prepare_str($_POST["filename"]);
	$resource_name=prepare_str($_POST["resource_name"]);
	
	$error=array();
	if ($filename==NULL){ $error["filename"]="<span class='errormessage'>Please enter a filename</span><br>\n"; }
	if ($node_id==NULL){ $error["node_id"]="<span class='errormessage'>Please specify a folder to create the resource in</span><br>\n"; }

	if (count($error)==0){
		if ($resource_id=="new"){
			//create a new resource
			$result=$resource->create($node_id,$filename,$notes);
			if ($result!==true){ fatal("Resource File Manager Fault - Resource creation failed - ".$result); }
			$resource_id=$resource->new_resource_id;
			
		} elseif ($version_id=="new"){
			//create a new version
			$result=$resource->new_version($resource_id,$node_id,$filename,$notes,time(),"post");
			if ($result!==true){ fatal("Resource File Manager Fault - Resource version creation failed - ".$result); }
			
		} else {
			//update an existing version
			$result=$resource->update($resource_id,$version_id,$node_id,$filename,$resource_name,$notes,time());
			if ($result!==true){ fatal("Resource File Manager Fault - Resource version update failed - ".$result); }
		}

		header ("Location: menu.php?resource_id=".$resource_id."&reload_menu=1"); exit();
	}
	
}

//******************************************************************************************************
// populate the form data where necessary (this is the headache bit)

//load any data objects
if ($resource_id=="new"){
	//set the defaults for a new resource
	if ($node_id==NULL){ fatal("Resource File Manager Fault - No parent node specified"); }
	
	$parent_path=$resource->node_path($node_id);
	$res=array();
		
} else {
	//we have an existing resource
	$version_id=request_key("version_id");
	
	if ($version_id=="new"){
		//new version of an existing resource
		$res=$resource->retrieve($resource_id); //retrieve the latest version
		if (!$res){ fatal("Resource File Manager Fault - Could not locate existing resource"); }
		
		$old_version_id=max(array_keys($res["versions"]));
		$node_id=$res["versions"][$old_version_id]["node_id"];
		//$version_id=$old_version_id+1; //don't set the version id, it throws the form method into update, we need revise
		
	} else { //--------------------------------------------------------------------
		if ($version_id==NULL){
			//no resource specified (use the latest version)
			$res=$resource->retrieve($resource_id); //retrieve the latest version
			if (!$res){ fatal("Resource File Manager Fault - Could not locate resource"); }
		} else {
			//load a specific resource version
			$res=$resource->retrieve_version($resource_id,$version_id);
			if (!$res){ fatal("Resource File Manager Fault - Could not locate resource version"); }			
		}
		$have_file=true;
		
		if (!$oldform){ //if it's not a submitted form, populate the non-static data
			$filename=$res["filename"];
			$node_id=$res["node_id"];
			$resource_name=$res["resource_name"];
		}
		
		$time_created=$res["time_created"];
		$parent_path=$res["path"];
		$checksum=$res["checksum"];
		//$path=$res["current_path"];
	}
	
	$resource_path=$CONFIG["system_datastore"]."/".$resource_id."/".$resource_id."-".$version_id;
}


//******************************************************************************************
//$b.="<input type='button' value='Return to Menu' onclick='window.location=\"resource_tree.php\"'><br><br>\n";

//pre($error);
//pre($resource);
$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' enctype='multipart/form-data' name='resource_file'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";
$b.="<input type='hidden' name='resource_id' value='".$resource_id."'>\n";
if ($node_id){ $b.="<input type='hidden' name='node_id' value='".$node_id."'>\n"; }
if ($version_id){ $b.="<input type='hidden' name='version_id' value='".$version_id."'>\n"; }


//pre($res);
$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Resource ID</th>\n";
$b.="<td>".$resource_id."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Version ID</th>\n";
$b.="<td>".$version_id."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Folder</th>\n";
//$b.="<td>".$resource->node_select("node_id",$node_id)."</td>\n"; //removed this, going to add a "move" button
$b.="<td>".$parent_path."</td>\n";
$b.="</tr>\n";

if ($have_file){ //only display the file information if a file has been uploaded
	$b.="<tr>\n";
	$b.="<th>File</th>\n";
	$b.="<td>".$filename." (".file_size($resource_path).")</td>\n";
	// <input type='submit' name='submit' value='Delete'>
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Checksum:</th>\n";
	$tip="An md5 checksum is a way of comparing different files.";
	$b.="<td>".$res["md5_sum"]." ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Filename:</th>\n";
	$tip="Must be a short filename.";
	$b.="<td>".$error["filename"]."<input type='text' name='filename' value='".$filename."' size='30' maxlength='30'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Resource Tag:</th>\n";
	$tip="The resource tag allows you to specify the filename of the resource (eg. tagname.pdf instead of 1251.pdf). A resource tag must be unique, no other resource on the website can use the same resource tag.";
	$b.="<td>".$error["resource_name"]."<input type='text' name='resource_name' value='".$resource_name."' size='30' maxlength='30'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Created</th>\n";
	if ($time_created){ $time_string=date("d/m/Y H:i:s",$time_created); } else { $time_string=NULL; }
	$b.="<td>".$time_string."</td>\n";
	$b.="</tr>\n";
} else {
	//<input type='submit' name='submit' value='Upload'>
	$b.="<tr>\n";
	$b.="<th>File</th>\n";
	$b.="<td><input type='file' size='40' name='new_resource' > </td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Filename</th>\n";
	$tip="Must be a short filename.";
	//$b.="<td>".$error["filename"]."<input type='text' name='filename' onfocus='bits=document.resource_file.new_resource.value.split(\"\\\\\");this.value=bits[bits.length-1];' value='".$filename."' size='30' maxlength='30'> ".tooltip($tip)."</td>\n";
	$b.="<td>".$error["filename"]."<input type='text' name='filename' onfocus='this.value=upload_filename(document.resource_file.new_resource.value);' value='".$filename."' size='30' maxlength='30'> ".tooltip($tip)."</td>\n";
	$b.="</tr>\n";	
}
$b.="</table><br>\n";

$b.="<input type='submit' name='submit' value='Update'>\n"; 
//if ($resource_id!="new"){ $b.="<input type='submit' name='submit' value='Approve'>\n"; }
if ($resource_id=="new"){ $return_id="node_id=".$node_id; } else { $return_id="resource_id=".$resource_id; }
//$b.=$return_id;
$b.="<br><br>";

$b.=button_href("Return to Menu","menu.php?".$return_id,"return.gif");

$b.="</form><br><br>\n";

$b.="<table border='1' class='dtable' width='100%'>\n";
$b.="<tr>\n";
$b.="<th>Revision Notes</th>\n";
$b.="</tr>\n";
$b.="<tr>\n";
if ($res["notes"]==NULL){ $res["notes"]="<blockquote><em><br>None.</em></blockquote>"; }
$b.="<td>".$res["notes"]." </td>\n";
$b.="</tr>\n";
$b.="</table>\n";

$b.="<br>\n";

$javascript["tooltip"]=1;
$javascript["dtree"]=1;
$javascript["upload_filename"]=1;
if ($oldform){ $javascript["reload_menu"]=1; }
$document=array();
$document["title"]="Resource Manager";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/skinny_template.php");
?>
