<?
/*
Stronghold CMS - Resource Folder Manager
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");
$resource=new resource($db,$CONFIG["db_table_prefix"]);
//pre($_GET);
//pre($_POST);
//calculate the node id and parent id's
$node_id=request_key("node_id");
if ($node_id==NULL){ fatal("Resource Folder Manager Fault - No node id specified"); }


if ($node_id==1){
	$document["title"]="Illegal Action";
	$document["body"]="You cannot modify the root folder.";
	include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");
	exit();
}

//process a form submission
$oldform=prepare_int($_POST["oldform"]);
if ($oldform){
	$parent_id=prepare_int($_POST["parent_id"]);
	$folder_name=prepare_str($_POST["folder_name"]);

	$error=array();
	//check for errors with file uploads	
	if ($folder_name==NULL){ $error["folder_name"]="<span class='errormessage'>Please enter a folder name.</span><br>"; }
	elseif (illegal_link($folder_name)){ $error["folder_name"]="<span class='errormessage'>Your folder name contains illegal characters.<br>You can use lowercase alpha numeric and underscores or dashes.</span><br>"; }
	if ($parent_id==NULL){ $error["parent_id"]="<span class='errormessage'>Please specify a parent</span><br>"; }
	
	if (count($error)==0){
	
		if ($node_id=="new"){
			//create a new folder
			$result=$resource->node_create($folder_name,$parent_id,$node_id); //$node_id is passed by reference
			if ($result!==true){ fatal ("Node creation failed - ".$result); } 
			
			header ("Location: menu.php?node_id=".$node_id."&load_node=".$node_id); exit();
			
		} else {
			//update an existing folder
			$sql="UPDATE ".$CONFIG["db_table_prefix"]."resource_tree SET node_name='".$folder_name."',node_parent=".$parent_id." WHERE node_id=".$node_id;
			$db->query($sql);
			//echo ($sql);
			
			header ("Location: menu.php?node_id=".$node_id."&load_node=".$node_id); exit();
		}
		//header ("Location: resource_tree.php?node_id=r".$resource_id); exit();
	}
} else {
	
	if ($node_id=="new"){
		//default values for a new entry
		$parent_id=prepare_int($_GET["parent_id"]);
		if ($parent_id==NULL){ fatal("Resource Folder Manager Fault - New node specified without a parent"); }
	
	} else {
		//preload a previous entry	
		$node=$resource->retrieve_node($node_id);
		if (!$node){ fatal("Resource Folder Manager Fault - Could not load specified node"); }
		$parent_id=$node["node_parent"];
		$folder_name=$node["node_name"];
	}
	
}

//pre($error);
//******************************************************************************************
// Begin HTML
$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' enctype='multipart/form-data'>\n";
$b.="<input type='hidden' name='oldform' value='1'>\n";
$b.="<input type='hidden' name='node_id' value='".$node_id."'>\n";

$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Folder ID:</th>\n";
$b.="<td>".$node_id."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Parent Folder:</th>\n";
$tip="The folder you would like to create your sub-folder in";
$b.="<td>".$error["parent"].$resource->node_select("parent_id",$parent_id)." ".tooltip($tip)."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Folder Name:</th>\n";
$tip="Folder names must be all lowercase, and only contain alpha-numeric characters.";
$b.="<td>".$error["folder_name"]."<input type='text' size='40' name='folder_name' value='".$folder_name."'> ".tooltip($tip)."</td>\n";
$b.="</tr>\n";
$b.="</table><br>\n";

$b.="<input type='submit' name='submit' value='Update'>\n";
if ($node_id=="new"){ $return_id=$parent_id; } else { $return_id=$node_id; }
$b.="<input type='button' value='Return to Menu' onclick='window.location=\"menu.php?node_id=".$return_id."\"'>\n";
$b.="</form><br><br>\n";

$b.="<br>\n";

$javascript["tooltip"]=1;
$javascript["dtree"]=1;
if ($oldform){ $javascript["reload_menu"]=1; }
$document=array();
$document["title"]="Resource Folder Manager";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/skinny_template.php");
?>
