<?
/*
Stronghold CMS - Resource Tree Menu
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

$requires_access=1; //access level required
include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");

//******************************************************************************************

$node_id=prepare_int($_GET["node_id"]);
$resource_id=prepare_int($_GET["resource_id"]);
if ($resource_id && $node_id){ fatal ("Resource Menu Fault - Cannot specify both a resource and a node"); }
if ($node_id===NULL && $resource_id===NULL){ fatal ("Resource Menu Fault - No node or resource specified"); }

//echo ("node:".$node_id."<br>");
//echo ("resource:".$resource_id."<br>");

//load the groups
$groups=retrieve_groups($db,$GLOBALS["CONFIG"]["db_table_prefix"]);

include ($_SERVER["DOCUMENT_ROOT"]."/_system/resource.php");
$resource=new resource($db,$CONFIG["db_table_prefix"]);

if ($resource_id){	
	foreach ($_SESSION[$GLOBALS["CONFIG"]["system_session"]."access"] AS $user_group_id => $value){ /* do nothing */ } //get the group id (dodgy)

	//load the resource
	$res=$resource->retrieve($resource_id,true);
	$current_version=$res["versions"][$res["current_version"]];
	//pre($res);
	
	$sql="SELECT l.version_id,l.user_id,l.timestamp,l.event,r.ref_val AS event_label,u.firstname,u.surname,u.email
	FROM ".$CONFIG["db_table_prefix"]."resource_log AS l
	LEFT JOIN ".$CONFIG["db_common_prefix"]."refs AS r ON (r.ref='editlog' AND l.event=r.ref_id)
	LEFT JOIN ".$CONFIG["db_common_prefix"]."users AS u ON (l.user_id=u.user_id)
	WHERE resource_id=".$resource_id."
	ORDER BY timestamp DESC	";
	$rs=$db->query($sql);
	$logs=array();
	foreach ($rs as $id => $r){ $logs[$r["version_id"]][]=$r; }
	//echo ptable($rs);
	//$logs=key_array($rs,"version_id");
	//pre($logs);
	
	//echo ptable($logs);

	//define the navigation buttons, we use them again at the end	
	$nav_buttons=button_href("Return to Menu","menu.php?node_id=".$current_version["node_id"],"return.gif");
	$nav_buttons.=button_href("New Version","file.php?resource_id=".$resource_id."&version_id=new","new_version.gif");
	$nav_buttons.=button_href("Archive","/stronghold/confirm.php?mode=archive_resource&resource_id=".$resource_id,"archive.gif");

	$b.=$nav_buttons;
	$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."'>\n";
	$b.="<input type='hidden' name='oldform' value='1'>\n";
	$b.="<table border='1' class='dtable' width='400'>\n";
	$b.="<tr>\n";
	$b.="<th width='10%'><nobr>Resource ID:</nobr></th>\n";
	$b.="<td width='90%'><nobr>".$resource_id."</nobr></td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th width='10%'><nobr>External Path</nobr></th>\n";
	$fetch_path="/resources/".$resource_id.".".$current_version["file_type"];
	$b.="<td width='90%'><nobr><a href=\"javascript:SelectFile('".$fetch_path."');\">".$fetch_path."</a></nobr></td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th width='10%'><nobr>Internal Path</nobr></th>\n";
	$b.="<td width='90%'><nobr>".$res["current_path"]."</nobr></td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Created</th>\n";
	$b.="<td>".date("d/m/Y H:i:s",$res["time_created"])."</td>\n";
	$b.="</tr>\n";
	$b.="<tr>\n";
	$b.="<th>Versions</th>\n";
	$b.="<td>";
		$b.="<table border='1' class='dtable' width='100%'>\n";
		$b.="<tr>\n";
		$b.="<th width='10'>#</th>\n";
		$b.="<th width='79%'>File</th>\n";
		$b.="<th width='20%'>Status</th>\n";
		//$b.="<th width='20%'>Approvals</th>\n";
		//$b.="<th>Update</th>\n";
		$b.="</tr>\n";
		$md5_tip="An md5 checksum is a way of uniquely identifying files.";
		foreach ($res["versions"] as $version_id => $r){ //for each version
			$file=$CONFIG["system_datastore"]."/".$resource_id."/".$resource_id."-".$version_id; //build the datastore path
			$b.="<tr>\n";
			$b.="<td>".$version_id."</td>\n";
			if (file_exists($file)){ //if the file exists in the datastore
				$b.="<td>";
					$b.="<nobr>".$r["filename"]." (".file_size($file).")</nobr><br>\n";
					$b.="<nobr><span class='footnote'>".$r["md5_sum"]."</span> ".tooltip($md5_tip)."</nobr><br>\n";
					if ($r["resource_name"]){ $b.="<br><strong>Resource Tag:</strong><br>\n".$r["resource_name"]."<br>\n"; } //display the resource name if one has been applied

					$b.="<table border='1' class='dtable' width='100%'><tr><td colspan='2'>";
					$b.="<nobr><strong>".$r["status_text"]."</strong></nobr><br>\n";
					foreach ($res["workflows"] as $id => $group_id){ //foreach workflow
						if (in_array($group_id,$r["approvals"])){ $class="approved"; } else { $class="not_approved"; }
						$b.="<nobr><span class='".$class."'>".$groups[$group_id]."</span></nobr><br>\n";
					}
					$b.="</td></tr>\n";
//					$b.="<table border='1' class='dtable' width='100%'><tr><td>";
					if (is_array($logs[$version_id])){
						foreach ($logs[$version_id] as $id => $l){
								$b.="<tr>\n";
								$b.="<td>".$l["event_label"]."</td>\n";
								$b.="<td><span class='footnote'>".date("d/m/Y H:i",$l["timestamp"])."</span><br>\n";
								$b.="<a href='mailto:".$l["email"]."'>".$l["firstname"]." ".$l["surname"]."</a></td>\n";
								$b.="</tr>\n";
						}
					}
					$b.="</table>\n";
				$b.="</td>\n";
			} else {
				$b.="<td colspan='2'><span class='errormessage'>Missing file! ".$file."</span></td>\n";
			}
			
			$b.="<td>";
			
			//approve button
			if (in_array($user_group_id,$r["approvals"]) || $r["status"]==4){ $disabled=true; } else { $disabled=false; } //if not already approved and not cancelled
			$b.=button_href("Approve","file.php?approve=1&resource_id=".$resource_id."&version_id=".$version_id,"approve.gif",$disabled);
			
			//cancel button
			if ($r["status"]==4){ $disabled=true; } else { $disabled=false; }
			$b.=button_href("Cancel","file.php?cancel=1&resource_id=".$resource_id."&version_id=".$version_id,"cancel_version.gif",$disabled);
			
			//update button
			if ($r["status"]>=3){ $disabled=true; } else { $disabled=false; }
			$b.=button_href("Update","file.php?resource_id=".$resource_id."&version_id=".$version_id,"save.gif",$disabled);

			//view button
			$b.=button_href("View","/stronghold/fetch.php?resource_id=".$resource_id."&version_id=".$version_id,"view.gif");

			$b.="</tr>\n";
		}
		$b.="</table>\n";

	$b.="</td>\n";
	$b.="</tr>\n";
	
	$b.="<tr>\n";
	$b.="<th>Usage</th>\n";
	$b.="<td>\n";
		//pre($current_version);
		$sql="SELECT p.url,c.ref_val,h.title,m.page_id,m.version_id".
			" FROM ".$CONFIG["db_table_prefix"]."module_text AS m,".$CONFIG["db_table_prefix"]."module AS h,".$CONFIG["db_common_prefix"]."refs AS c,".$CONFIG["db_table_prefix"]."pages AS p".
			" WHERE body_text LIKE '%/resources/".$resource_id.".".$current_version["file_type"]."%'".
			" AND h.page_id=m.page_id".
			" AND h.version_id=m.version_id".
			" AND m.page_id=p.page_id".
			" AND c.ref='status'".
			" AND h.status=c.ref_id";
//echo ($sql);
		$rs=$db->query($sql);
		//echo ptable($rs);
		
		$c=count($rs);
		if ($c>0){
			$b.="<em>".$c." documents</em>";
			$b.="<table border='1' width='100%' class='dtable'>";
			foreach ($rs as $id => $r){
				$link=$r["url"]."?version_id=".$r["version_id"];
				$b.="<tr>\n";
				$b.="<td width='1%'>".$r["page_id"].".".$r["version_id"]."</td>\n";
				$b.="<td width='98%'><nobr>".$r["title"]."</nobr><br><nobr><a href='".$link."' target='_top'>".$link."</a></nobr>\n</td>\n";
				$b.="<td width='1%'>".$r["ref_val"]."</td>\n";
				$b.="</tr>\n";
			}
			$b.="</table>\n";
		} else {
			$b.="<em>None</em>";
		}
		
	$b.="</td>\n";
	$b.="</tr>\n";
	$b.="</table><br>\n";
	$b.=$nav_buttons;
	$b.="</form>\n";
	
	if (in_array($current_version["file_type"],array("gif","jpg","png"))){ $b.="<img src='".$fetch_path."'>";  }

} elseif ($node_id) { //**************************************************************************************************************************
	//display a folder
	$kids=$resource->child_nodes($node_id);
	//pre($kids);

	$buttons=button_href("New Resource","file.php?resource_id=new&node_id=".$node_id,"new_resource.gif")." ";
	$buttons.=button_href("New Sub-Folder","folder.php?node_id=new&parent_id=".$node_id,"new_folder.gif")." ";
	$buttons.=button_href("Modify Folder","folder.php?node_id=".$node_id,"modify_folder.gif");
	/*
	$buttons="<input type='button' value='New Resource' onclick='window.location=\"file.php?resource_id=new&node_id=".$node_id."\"'>\n";
	$buttons.="<input type='button' value='New Sub-Folder' onclick='window.location=\"folder.php?node_id=new&parent_id=".$node_id."\"'>\n";
	$buttons.="<input type='button' value='Modify Folder' onclick='window.location=\"folder.php?node_id=".$node_id."\"'>\n";
	*/
	
	$b.=$buttons."<br><br>";
	$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."'>\n";
	$b.="<input type='hidden' name='oldform' value='1'>\n";
	$b.="<table border='1' class='dtable' width='100%'>\n";
	$b.="<tr>\n";
	$b.="<th width='1%'></th>\n";
	$b.="<th width='69%'><nobr>File Name</nobr></th>\n";
	$b.="<th width='10%'>Size</th>\n";
	$b.="<th width='10%'>Type</th>\n";
	$b.="<th width='10%'>Modified</th>\n";
	$b.="</tr>\n";
	if (count($kids["folders"])==0 && count($kids["files"])==0){ //if it's an empty folder
		$b.="<tr><td></td><td colspan='5'><blockquote><em><br>No files in this folder</em></blockquote></td></tr>\n";
	} else {
		foreach ($kids["folders"] as $kid_node_id => $kid_node){
			//display folders
			$b.="<tr>\n";
			$b.="<td><img src='/includes/dtree/img/folder.gif' alt='Folder'></td>\n";
			$b.="<td><a href='menu.php?node_id=".$kid_node_id."&load_node=".$kid_node_id."'>".$kid_node["node_name"]."</a></td>\n";
			$b.="<td>".$kid_node["a"]."</td>\n";
			$b.="<td>Folder</td>\n";
			$b.="<td>".$kid_node["a"]."</td>\n";
			$b.="</tr>\n";
		}
		foreach ($kids["files"] as $resource_id => $resource){
			//display files
			$b.="<tr>\n";
			$b.="<td>".file_icon($resource["filename"])."</td>\n";
			$b.="<td><a href='menu.php?resource_id=".$resource_id."'>".$resource["filename"]."</a></td>\n";
			$b.="<td align='right'>".file_size($CONFIG["system_datastore"]."/".$resource_id."/".$resource_id."-".$resource["version_id"])."</td>\n";
			$b.="<td>".$resource["file_type"]."</td>\n";
			$b.="<td>".$resource["a"]."</td>\n";
			$b.="</tr>\n";
		}
	}
	$b.="</table><br><br>\n";
	$b.=$buttons;
	$b.="</form>\n";

} else {
	fatal("Resource Menu Fault: Not a recognised type");
}


$b.="<br>\n";

$javascript["tooltip"]=1;
if ($_GET["reload_menu"]==1){ $javascript["reload_menu"]=1; } //direct compare, no need for prepare_int
if ($_GET["load_node"]){ $javascript["load_node"]=prepare_int($_GET["load_node"]); }

//if ($node_type=="n"){ $javascript["load_node"]=$node_id; }

$document=array();
$document["title"]="Resource Manager";
$document["body"]=$b;
include ($_SERVER["DOCUMENT_ROOT"]."/includes/skinny_template.php");
?>
