<?
/*
Stronghold CMS - User Maintenance
Copyright (C) 2008 Scott Barnett

This program is free software; you can redistribute it and/or
modify it under the terms of Version 3 of the GNU General Public
License as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

//libraries (+ugly include hack)
if (is_dir($_SERVER["DOCUMENT_ROOT"]."/labyrinth")){ include ($_SERVER["DOCUMENT_ROOT"]."/_system/labyrinth.php"); }
else { include ($_SERVER["DOCUMENT_ROOT"]."/_system/stronghold.php"); }

$requires_access=4;
include ($_SERVER["DOCUMENT_ROOT"]."/_system/session.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/extended.php");
include ($_SERVER["DOCUMENT_ROOT"]."/_system/adLDAP.php");

if (is_dir($_SERVER["DOCUMENT_ROOT"]."/labyrinth")){
	//called from labyrinth
	if (labyrinth_has_admin($_SESSION["labyrinth_groups"])){  $user_id=request_key("user_id"); }
	else { $user_id=$_SESSION[$CONFIG["system_session"]."userid"]; }
} else {
	//called from stronghold
	if (has_admin($_SESSION[$CONFIG["system_session"]."access"])){ $user_id=request_key("user_id"); }
	else { $user_id=$_SESSION[$CONFIG["system_session"]."userid"]; }
}

$access_levels=retrieve_useraccess($db,$CONFIG["db_common_prefix"]);

$changed=false;
if ($_POST){ //have a submitted form
	$adsearch=prepare_str($_POST["adsearch"]);

	if ($adsearch==NULL){
		if ($user_id==NULL){ fatal("User Maintenance Fault: No user_id specified"); }

		$username=prepare_str($_POST["username"]);
		$firstname=prepare_str($_POST["firstname"]);
		$surname=prepare_str($_POST["surname"]);
		$email=prepare_str($_POST["email"]);
		$access=prepare_int($_POST["access"]);
		$editor_size=prepare_str($_POST["editor_size"]);
	
		$errors=array();
		if ($username==NULL){ $errors["username"]="<span class='errormessage'>Please enter a username</span><br>\n"; }
		if ($firstname==NULL){ $errors["firstname"]="<span class='errormessage'>Please enter a first name</span><br>\n"; }
		if ($surname==NULL){ $errors["surname"]="<span class='errormessage'>Please enter a surname</span><br>\n"; }
		if ($access==NULL){ $errors["access"]="<span class='errormessage'>Please select an access level</span><br>\n"; }
		if ($email==NULL){ $errors["email"]="<span class='errormessage'>Please enter an email address</span><br>\n"; }
		elseif (!vemail($email)){ $errors["email"]="<span class='errormessage'>Please enter a valid email address</span><br>\n"; }
		if ($editor_size==NULL){ $errors["username"]="<span class='errormessage'>Please enter an editor size</span><br>\n"; }
	
		if (count($errors)==0){
			$fields=array();
			$fields["username"]=$username;
			$fields["firstname"]=$firstname;
			$fields["surname"]=$surname;
			$fields["access"]=$access;
			$fields["email"]=$email;
			$fields["editor_size"]=$editor_size;
			$fields["active"]=1;
			if ($user_id=="new"){
				$user_id=user_create($db,$CONFIG["db_common_prefix"],$fields);
				if (!$user_id){ $create_error="User creation failed, the username already exists!"; }
				else { $changed=true; }
			} else {
				user_modify($db,$CONFIG["db_common_prefix"],$user_id,$fields);
				$changed=true;
			}
		}
	} else {
		$adldap = new adLDAP(adldap_config($CONFIG));
		$foo=$adldap->user_info($adsearch,array("mail","displayname"));

		if ($foo["count"]!=0){
			$username=$adsearch;
			$email=$foo[0]["mail"][0];
			$name=explode(" ",$foo[0]["displayname"][0]);
			$firstname=$name[0];
			$surname=$name[1];
			$editor_size="700x400";
			$access=1;
		} else {
			$no_results=true;
			$user_id="new";
		}
	}
}

	if ($user_id==NULL){ $user_id="new"; }
	
	//first form load, set default values
	if ($user_id=="new"){
		//default values for a new entry
		$access=1;
		$editor_size="700x400";

	} else {
		//load an existing entry
		$user=retrieve_user($db,$db_table_prefix,"user_id",$user_id);
		$username=$user["username"];
		$firstname=$user["firstname"];
		$surname=$user["surname"];
		$access=$user["access"];
		$email=$user["email"];
		$editor_size=$user["editor_size"];
	}
	
//pre($errors);
//----------------------------------------------------------------------------------------------------------------------



$b.="<form method='post' action='".prepare_str($_SERVER["PHP_SELF"])."' name='user_maintenance'>\n";
$b.="<input type='hidden' name='user_id' value='".$user_id."'>\n";

$b.="<table border='1' class='dtable' cellspacing='0' cellpadding='4'>\n";
$b.="<tr><th>Add Account (Username Search)</th></tr>\n";
$b.="<tr><td><input type='text' name='adsearch' value=''> ".button_submit("user_maintenance","search","Search","search.gif")."</td></tr>\n";
$b.="</table><br>\n";

if ($no_results){ $b.="<span class='errormessage'>Username '".$adsearch."' not found!</span><br><br>"; }

$b.="<table border='1' class='dtable'>\n";
$b.="<tr>\n";
$b.="<th>Username:</th>\n";
$b.="<td>".$errors["username"]."<input type='text' name='username' value='".$username."'></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Firstname:</th>\n";
$b.="<td>".$errors["firstname"]."<input type='text' name='firstname' value='".$firstname."'></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Surname:</th>\n";
$b.="<td>".$errors["surname"]."<input type='text' name='surname' value='".$surname."'></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Access:</th>\n";
$b.="<td>".$errors["access"].generic_select("access",$access_levels,$access,true,false)."</td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Email:</th>\n";
$b.="<td>".$errors["email"]."<input type='text' name='email' value='".$email."' size='40'></td>\n";
$b.="</tr>\n";
$b.="<tr>\n";
$b.="<th>Editor Size:</th>\n";
$b.="<td>".$errors["editor_size"]."<input type='text' name='editor_size' value='".$editor_size."' maxlength='11'></td>\n";
$b.="</tr>\n";
/*
$b.="<tr>\n";
$b.="<th>Password:</th>\n";
$b.="<td>".$errors["password"]."<input type='text' name='password1' value='".$password1."'><input type='text' name='password2' value='".$password2."'></td>\n";
$b.="</tr>\n";
*/
$b.="</table>\n";
if ($changed){ $b.="<br>Your changes have been saved.\n"; }
if ($create_error){ $b.="<br><span class='errormessage'>".$create_error."</span>\n"; }

$b.="<br><br>\n";
if ($user_id=="new"){ $b.=button_submit("user_maintenance","create","Create","user_create.gif"); }
else { $b.=button_submit("user_maintenance","update","Update","save.gif"); }
$b.=button_href("Return to Menu","users.php","return.gif");
$b.="</form>";

$document=array();
$document["title"]="User Maintenance";
$document["body"]=$b;

include ($_SERVER["DOCUMENT_ROOT"]."/includes/template.php");

function editor_size_check($size){
	$bits=explode("x",strtolower($size));
	if (count($bits)!=2){ return (false); }
	if (!is_numeric($bits[0])){ return (false); }
	if (!is_numeric($bits[1])){ return (false); }
	return (true);
}
?>